function init()
    door = FindShape("atticdoor")
    motor1 = FindJoint("motor1")
    motor2 = FindJoint("motor2")

    OpenTarget = GetFloatParam("OpenTarget", 62)
    ClosedTarget = GetFloatParam("ClosedTarget", 0)

    CloseSpeed = GetFloatParam("CloseSpeed", 1)
    OpenSpeed =  GetFloatParam("OpenSpeed", 1)
	DoorsOpening = false

end

function tick(dt)
	broken = IsShapeBroken(door)

    if not broken then
        if GetPlayerInteractShape() == door and InputPressed("interact") then
	        if not DoorsOpening then
			    DoorsOpening = true
			else
				DoorsOpening = false
			end
        end
    end

    if not DoorsOpening then
	    SetTag(door, "interact", "close")
        SetJointMotorTarget(motor1, OpenTarget, OpenSpeed)
        SetJointMotorTarget(motor2, OpenTarget, OpenSpeed)
    else
	    SetTag(door, "interact", "open")
        SetJointMotorTarget(motor1, ClosedTarget, CloseSpeed)
        SetJointMotorTarget(motor2, ClosedTarget, CloseSpeed)
    end
end