function init()
	dishwasher = FindShape("dish")
    wireplug = FindShape("wireplug")
	cable = FindJoint("cable")
	plugbox = FindTrigger("plugbox")
	dishLight = FindLight("dish")
	dishOn = false
	washOn = false
	
    masterfuseMotor = FindJoints("fusemaster", true)
	masterfuse = FindShape("fusemaster", true)
	masterfuseOn = true
	
	fuse = FindShape("fusekitchen", true)
    fuseMotor = FindJoints("fusekitchen", true)
	fusebox = FindShape("fusebox", true)
	fuseOn = true
	
	powercable1 = FindJoint("powercable1", true)
	powercable2 = FindJoint("powercable2", true)
	powercable3 = FindJoint("powercable3", true)
	powercable4 = FindJoint("powercable4", true)
	powercable5 = FindJoint("powercable5", true)
	powercable6 = FindJoint("powercable6", true)
	powercable7 = FindJoint("powercable7", true)
	powercable8 = FindJoint("powercable8", true)
	powercable9 = FindJoint("powercable9", true)
	powercable10 = FindJoint("powercable10", true)
	powercable11 = FindJoint("powercable11", true)
	powercable12 = FindJoint("powercable12", true)
	powercable13 = FindJoint("powercable13", true)
	powercable14 = FindJoint("powercable14", true)
	powercable15 = FindJoint("powercable15", true)
	powercable16 = FindJoint("powercable16", true)
end

function tick(dt)	
	cable1 = IsJointBroken(powercable1)
	cable2 = IsJointBroken(powercable2)
	cable3 = IsJointBroken(powercable3)
	cable4 = IsJointBroken(powercable4)
	cable5 = IsJointBroken(powercable5)
	cable6 = IsJointBroken(powercable6)
	cable7 = IsJointBroken(powercable7)
	cable8 = IsJointBroken(powercable8)
	cable9 = IsJointBroken(powercable9)
	cable10 = IsJointBroken(powercable10)
	cable11 = IsJointBroken(powercable11)
	cable12 = IsJointBroken(powercable12)
	cable13 = IsJointBroken(powercable13)
	cable14 = IsJointBroken(powercable14)
	cable15 = IsJointBroken(powercable15)
	cable16 = IsJointBroken(powercable16)
	broken1 = IsShapeBroken(dishwasher)
	broken2 = IsJointBroken(cable)

	if GetPlayerInteractShape() == masterfuse and InputPressed("interact") then
        if masterfuseOn then
			fuseOn = false
			masterfuseOn = false
	    else
			masterfuseOn = true
		end
	end	
	
	if not IsShapeBroken(fusebox) then
        if masterfuseOn then
	        SetTag(masterfuse, "interact", "turn off")
		    for i=1, #masterfuseMotor do
	        local motor = masterfuseMotor[i]
                SetJointMotorTarget(motor, -35, 5)
		    end
	    else
	        SetTag(masterfuse, "interact", "turn on")
		    for i=1, #masterfuseMotor do
	        local motor = masterfuseMotor[i]
                SetJointMotorTarget(motor, 35, 5)
		    end
	    end
	else
        if masterfuseOn then
	        SetTag(masterfuse, "interact", "broken")
		    for i=1, #masterfuseMotor do
	        local motor = masterfuseMotor[i]
                SetJointMotorTarget(motor, -35, 5)
		    end
	    else
	        SetTag(masterfuse, "interact", "broken")
		    for i=1, #masterfuseMotor do
	        local motor = masterfuseMotor[i]
                SetJointMotorTarget(motor, 35, 5)
		    end
	    end
	end	
	if masterfuseOn then
	    if GetPlayerInteractShape() == fuse and InputPressed("interact") then
            if fuseOn then
			    fuseOn = false
	        else
                fuseOn = true
		    end
	    end	
	else
	    if GetPlayerInteractShape() == fuse and InputPressed("interact") then
            if fuseOn then
			    fuseOn = false
	        else
                fuseOn = false
		    end
	    end	
	end	
	
    if GetPlayerInteractShape() == dishwasher and InputPressed("interact") then
		if IsShapeInTrigger(plugbox, wireplug) then
		    if not dishOn then
				dishOn = true
			else
				dishOn = false
			end
	    end
	end
	
	if IsShapeBroken(fusebox) then
	    if fuseOn then
		    if dishOn then
			    washOn = false
			else
			    washOn = false
			end
	    else
		    if dishOn then
			    washOn = false
			else
			    washOn = false
			end
        end				
	else
	    if fuseOn then
		    if dishOn then
			    washOn = true
			else
			    washOn = false
			end
	    else
		    if dishOn then
			    washOn = false
			else
			    washOn = false
			end
        end		
	end
    if IsShapeInTrigger(plugbox, wireplug) then	
	    if dishOn then
			SetTag(dishwasher, "interact", "Turn off")
		else
			SetTag(dishwasher, "interact", "Turn on")
		end
	else
	    if dishOn then
			SetTag(dishwasher, "interact", "Turn off")
		else
			SetTag(dishwasher, "interact", "Turn on")
		end
    end

	if not broken1 and not broken2 and not cable1 and not cable2 and not cable3 and not cable4 and not cable5 and not cable6 and not cable7 and not cable8 and not cable9 and not cable10 and not cable11 and not cable12 and not cable13 and not cable14 and not cable15 and not cable16 then
		if IsShapeInTrigger(plugbox, wireplug) then	
		    if not washOn then
			    SetLightEnabled(dishLight, false)
       		else
			    SetLightEnabled(dishLight, true)	
			end
		else
		    if washOn then
			    SetLightEnabled(dishLight, false)
			else
			    SetLightEnabled(dishLight, false)
			end
		end
	else
		if IsShapeInTrigger(plugbox, wireplug) then	
		    if not washOn then
			    SetLightEnabled(dishLight, false)
       		else
			    SetLightEnabled(dishLight, false)	
			end
		else
		    if washOn then
			    SetLightEnabled(dishLight, false)
			else
			    SetLightEnabled(dishLight, false)
			end
		end
	end
end