function init()
    lock = FindShape("lock1")
	
    motors1 = FindJoints("motor1")
	
    motor1 = FindJoint("doorknob1")
	
	door = FindShape("door1")
	
	framelock = FindShape("framelock1")
	
	trigger1 = FindTrigger("doortrigger1")
	
	SetBool("level.doorlock", false)
end

function tick(dt)
	broken1 = IsShapeBroken(framelock)
	broken2 = IsShapeBroken(lock)
	
	doorlocked = GetBool("level.doorlock")
    if doorlocked then
        SetTag(lock, "interact", "locked")
	else
        SetTag(lock, "interact", "unlocked")
	end

	if IsShapeInTrigger(trigger1, door) then
	    if GetPlayerInteractShape() == lock and InputPressed("interact") then
	        if not doorlocked then
		        SetBool("level.doorlock", true)
	        else
		        SetBool("level.doorlock", false)
			end
	    end
	end
	if GetString("game.player.tool") == "key" then
	    if InputPressed("usetool") then
		        SetBool("level.doorlock", true)
		end
	end
	if not broken1 or not broken2 then
	    if doorlocked then
            for i=1,#motors1 do
                local motor1 = motors1[i]
                SetJointMotorTarget(motor1, 0, 10)
            end
	    else
		    if IsShapeInTrigger(trigger1, door) then
			    local body1 = GetPlayerGrabShape("door")
			    if body1 ~= 1 then
			        for i=1,#motors1 do
                        local motor1 = motors1[i]
                        SetJointMotorTarget(motor1, 0, 10, 10000)
					end
			    end
			    if body1 ~= 0 then
                    for i=1,#motors1 do
                        local motor1 = motors1[i]
                        SetJointMotorTarget(motor1, 0, 0, 50)
					end
				end
			end
        end
	end
	if broken1 or broken2 then
	    if doorlocked then
            for i=1,#motors1 do
                local motor1 = motors1[i]
                SetJointMotorTarget(motor1, 0, 0, 10)
            end
	    else
            for i=1,#motors1 do
                local motor1 = motors1[i]
                SetJointMotorTarget(motor1, 0, 0, 10)
			end
        end
	end

end