detectRange = 3


function init()
    laser = FindBody("laser", true)
	light = FindLight("light")
end

function tick(dt)
    local laser = GetBodyTransform(laser)
	local player = GetPlayerTransform()
	local playerPos = player.pos
	
	local b = Vec(3,0,0)
	local origin = VecSub(laser.pos)
	local endPoint = VecCopy(playerPos)
	local dist = VecLength(VecSub(origin, playerPos))
	
	DrawLine(origin, endPoint, 10,0,0)
	
	-- entrance
	local count1 = QueryAabbFireCount(Vec(1.2,0.6,-9.2), Vec(7.4,4.4,-2.3))
	-- guestbath
	local count2= QueryAabbFireCount(Vec(7.6,0.6,-9.3), Vec(11.9,4.4,-6.0))
	-- hallway1
	local count3 = QueryAabbFireCount(Vec(7.5,0.6,-5.9), Vec(12.1,4.4,0.2))	
	-- hallway2
	local count4 = QueryAabbFireCount(Vec(5.6,0.6,-2.1), Vec(7.8,4.4,10.3))
	-- kitchen1
	local count5 = QueryAabbFireCount(Vec(8.2,0.6,0.3), Vec(12.1,4.4,10.7))
	-- kitchen2
	local count6 = QueryAabbFireCount(Vec(5.8,0.6,10.7), Vec(12.1,4.4,15.6))
	-- livingroom
	local count7 = QueryAabbFireCount(Vec(-12.9,0.6,7.5), Vec(5.7,4.4,15.6))
	-- bedroom1
	local count8 = QueryAabbFireCount(Vec(-12.9,0.6,-9.3), Vec(-7.8,4.4,-2.1))
	-- bedroom2
	local count9 = QueryAabbFireCount(Vec(-12.9,0.6,-2.1), Vec(-5.4,4.4,7.4))
	-- mainbath
	local count10 = QueryAabbFireCount(Vec(-7.7,0.6,-9.3), Vec(-2.1,4.4,-2.5))
	
	
	DrawLine(count, endPoint, 10,0,0)

	 
	-- entrance
	
	DebugCross(Vec(1.2,0.6,-9.2))
	DebugCross(Vec(7.4,4.4,-2.3))
	DrawLine(Vec(1.2,0.6,-9.2), Vec(7.4,4.4,-2.3), 10,0,0)
	
	-- guestbath
	
	debug1 = DebugCross(Vec(7.6,0.6,-9.3))
	debug2 = DebugCross(Vec(11.9,4.4,-6.0))
	DrawLine(Vec(7.6,0.6,-9.3), Vec(11.9,4.4,-6.0), 10,0,0)
	
	-- hallway1
	
	DebugCross(Vec(7.5,0.6,-5.9))
	DebugCross(Vec(12.1,4.4,0.2))
	DrawLine(Vec(7.5,0.6,-5.9), Vec(12.1,4.4,0.2), 10,0,0)
	
	-- hallway2
	
	DebugCross(Vec(5.6,0.6,-2.1))
	DebugCross(Vec(7.8,4.4,10.3))
	DrawLine(Vec(5.6,0.6,-2.1), Vec(7.8,4.4,10.3), 10,0,0)
	
	-- kitchen1
	
	DebugCross(Vec(8.2,0.6,0.3))
	DebugCross(Vec(12.1,4.4,10.7))
	DrawLine(Vec(8.2,0.6,0.3), Vec(12.1,4.4,10.7), 10,0,0)
	
	-- kitchen2
	
	DebugCross(Vec(5.8,0.6,10.7))
	DebugCross(Vec(12.1,4.4,15.6))
	DrawLine(Vec(5.8,0.6,10.7), Vec(12.1,4.4,15.6), 10,0,0)
	
	-- livingroom
	DebugCross(Vec(-12.9,0.6,7.5))
	DebugCross(Vec(5.7,4.4,15.6))
	DrawLine(Vec(-12.9,0.6,7.5), Vec(5.7,4.4,15.6), 10,0,0)
	
	-- bedroom1
	
	DebugCross(Vec(-12.9,0.6,-9.3))
	DebugCross(Vec(-7.8,4.4,-2.1))
	DrawLine(Vec(-12.9,0.6,-9.3), Vec(-7.8,4.4,-2.1), 10,0,0)
	
	-- bedroom2
	
	DebugCross(Vec(-12.9,0.6,-2.1))
	DebugCross(Vec(-5.4,4.4,7.4))
	DrawLine(Vec(-12.9,0.6,-2.1), Vec(-5.4,4.4,7.4), 10,0,0)
	
	-- mainbath
	
	DebugCross(Vec(-7.7,0.6,-9.3))
	DebugCross(Vec(-2.1,4.4,-2.5))
	DrawLine(Vec(-7.7,0.6,-9.3), Vec(-2.1,4.4,-2.5), 10,0,0)
	
	
	if count1>detectRange then
		DebugPrint("fire entrance")
	else
		DebugPrint("fire out entrance")
    end
	
	if count2>detectRange then
		DebugPrint("fire guestbath")
	else
		DebugPrint("fire out guestbath")
    end
	
	if count3>detectRange or count4>detectRange then
		DebugPrint("fire hallway")
	else
		DebugPrint("fire out hallway")
    end
	
	if count5>detectRange or count6>detectRange then
		DebugPrint("fire kitchen")
	else
		DebugPrint("fire out kitchen")
    end
	
	if count7>detectRange then
		DebugPrint("fire livingroom")
	else
		DebugPrint("fire out livingroom")
    end
	
	if count8>detectRange or count9>detectRange then
		DebugPrint("fire bedroom")
	else
		DebugPrint("fire out bedroom")
    end
	
	if count10>detectRange then
		DebugPrint("fire mainbath")
	else
		DebugPrint("fire out mainbath")
    end
	
	
end

