function init()
	lightswitch1 = FindShape("lightswitch1")
	lightswitch2 = FindShape("lightswitch2")
    light = FindShape("light")
	fuse = FindShape("fusekitchen", true)
	masterswitch = FindShape("masterswitch", true)
	myLights = FindLights("light")
    switchMotor	= FindJoints("switch")
    fuseMotor = FindJoints("fusekitchen", true)
	fusebox = FindShape("fusebox", true)
    lightOn = true
    OnSwitch = GetFloatParam("OnSwitch", 2)
    OffSwitch = GetFloatParam("OffSwitch", 0)
    fuseOn	= true
	
    masterfuseMotor = FindJoints("fusemaster", true)
	masterfuse = FindShape("fusemaster", true)
	masterfuseOn = true
	
    OnSpeed = GetFloatParam("OnSpeed", 2)
    OffSpeed =  GetFloatParam("OffSpeed", 2)
    switchOn = true
	SetTag(masterswitch, "interact")
	switchSound = LoadSound("MOD/script/lightswitch.ogg")

	powercable1 = FindJoint("powercable1", true)
	powercable2 = FindJoint("powercable2", true)
	powercable3 = FindJoint("powercable3", true)
	powercable4 = FindJoint("powercable4", true)
	powercable5 = FindJoint("powercable5", true)
	powercable6 = FindJoint("powercable6", true)
	powercable7 = FindJoint("powercable7", true)
	powercable8 = FindJoint("powercable8", true)
	powercable9 = FindJoint("powercable9", true)
	powercable10 = FindJoint("powercable10", true)
	powercable11 = FindJoint("powercable11", true)
	powercable12 = FindJoint("powercable12", true)
	powercable13 = FindJoint("powercable13", true)
	powercable14 = FindJoint("powercable14", true)
	powercable15 = FindJoint("powercable15", true)
	powercable16 = FindJoint("powercable16", true)
end

function tick(dt)
	cable1 = IsJointBroken(powercable1)
	cable2 = IsJointBroken(powercable2)
	cable3 = IsJointBroken(powercable3)
	cable4 = IsJointBroken(powercable4)
	cable5 = IsJointBroken(powercable5)
	cable6 = IsJointBroken(powercable6)
	cable7 = IsJointBroken(powercable7)
	cable8 = IsJointBroken(powercable8)
	cable9 = IsJointBroken(powercable9)
	cable10 = IsJointBroken(powercable10)
	cable11 = IsJointBroken(powercable11)
	cable12 = IsJointBroken(powercable12)
	cable13 = IsJointBroken(powercable13)
	cable14 = IsJointBroken(powercable14)
	cable15 = IsJointBroken(powercable15)
	cable16 = IsJointBroken(powercable16)

	local switch1Transform = GetShapeWorldTransform(lightswitch1)
	local switch1Position = switch1Transform.pos
	
	local switch2Transform = GetShapeWorldTransform(lightswitch2)
	local switch2Position = switch2Transform.pos

	if GetPlayerInteractShape() == masterfuse and InputPressed("interact") then
        if masterfuseOn then
			fuseOn = false
			masterfuseOn = false
	    else
			masterfuseOn = true
		end
	end	
	
	if not IsShapeBroken(fusebox) then
        if masterfuseOn then
	        SetTag(masterfuse, "interact", "turn off")
		    for i=1, #masterfuseMotor do
	        local motor = masterfuseMotor[i]
                SetJointMotorTarget(motor, -35, 5)
		    end
	    else
	        SetTag(masterfuse, "interact", "turn on")
		    for i=1, #masterfuseMotor do
	        local motor = masterfuseMotor[i]
                SetJointMotorTarget(motor, 35, 5)
		    end
	    end
	else
        if masterfuseOn then
	        SetTag(masterfuse, "interact", "broken")
		    for i=1, #masterfuseMotor do
	        local motor = masterfuseMotor[i]
                SetJointMotorTarget(motor, -35, 5)
		    end
	    else
	        SetTag(masterfuse, "interact", "broken")
		    for i=1, #masterfuseMotor do
	        local motor = masterfuseMotor[i]
                SetJointMotorTarget(motor, 35, 5)
		    end
	    end
	end	
	if masterfuseOn then
	    if GetPlayerInteractShape() == fuse and InputPressed("interact") then
            if fuseOn then
			    fuseOn = false
	        else
                fuseOn = true
		    end
	    end	
	else
	    if GetPlayerInteractShape() == fuse and InputPressed("interact") then
            if fuseOn then
			    fuseOn = false
	        else
                fuseOn = false
		    end
	    end	
	end
	
	if not IsShapeBroken(fusebox) then
        if fuseOn then
	        SetTag(fuse, "interact", "turn off")
		    for i=1, #fuseMotor do
	        local motor = fuseMotor[i]
                SetJointMotorTarget(motor, -35, 5)
		    end
	    else
	        SetTag(fuse, "interact", "turn on")
		    for i=1, #fuseMotor do
	        local motor = fuseMotor[i]
                SetJointMotorTarget(motor, 35, 5)
		    end
	    end
	else
        if fuseOn then
	        SetTag(fuse, "interact", "broken")
		    for i=1, #fuseMotor do
	        local motor = fuseMotor[i]
                SetJointMotorTarget(motor, -35, 5)
		    end
	    else
	        SetTag(fuse, "interact", "broken")
		    for i=1, #fuseMotor do
	        local motor = fuseMotor[i]
                SetJointMotorTarget(motor, 35, 5)
		    end
	    end

	end	
		
    if GetPlayerInteractShape() == lightswitch1 and InputPressed("interact") then
	    if switchOn then
		    switchOn = false
	    else
		    switchOn = true
		end
		PlaySound(switchSound, switch1Position, 1)
	end
    if GetPlayerInteractShape() == lightswitch2 and InputPressed("interact") then
	    if switchOn then
		    switchOn = false
	    else
		    switchOn = true
		end
		PlaySound(switchSound, switch2Position, 1)
	end
	
	if IsShapeBroken(fusebox) then
	    if fuseOn then
		    if switchOn then
			    lightOn = false
			else
			    lightOn = false
			end
	    else
		    if switchOn then
			    lightOn = false
			else
			    lightOn = false
			end
        end				
	else
		if fuseOn then
	        if switchOn then
		        lightOn = true
		    else
		        lightOn = false
		    end
	    else
	        if switchOn then
		        lightOn = false
		    else
		        lightOn = false
		    end
		end
	end
	
	if not cable1 and not cable2 and not cable3 and not cable4 and not cable5 and not cable6 and not cable7 and not cable8 and not cable9 and not cable10 and not cable11 and not cable12 and not cable13 and not cable14 and not cable15 and not cable16  then
	    if not IsShapeBroken(light) then
	        if lightOn then
	            for i=1, #myLights do
	            local light = myLights[i]
		            SetLightEnabled(light, true)
	            end
	        else
	            for i=1, #myLights do
	            local light = myLights[i]
		            SetLightEnabled(light, false)
	            end
	        end
	    else
	        if lightOn then
	            for i=1, #myLights do
	            local light = myLights[i]
		            SetLightEnabled(light, false)
	            end
	        else
	            for i=1, #myLights do
	            local light = myLights[i]
		            SetLightEnabled(light, false)
	            end
			end
	    end
	else
	    if not IsShapeBroken(light) then
	        if lightOn then
	            for i=1, #myLights do
	            local light = myLights[i]
		            SetLightEnabled(light, false)
	            end
	        else
	            for i=1, #myLights do
	            local light = myLights[i]
		            SetLightEnabled(light, false)
	            end
	        end
	    else
	        if lightOn then
	            for i=1, #myLights do
	            local light = myLights[i]
		            SetLightEnabled(light, false)
	            end
	        else
	            for i=1, #myLights do
	            local light = myLights[i]
		            SetLightEnabled(light, false)
	            end
			end
	    end
	end
	
	if not IsShapeBroken(light) then
	    if not switchOn then
		    for i=1, #switchMotor do
			local motor = switchMotor[i]
                SetJointMotorTarget(motor, OnSwitch, OnSpeed)
			end
	        SetTag(lightswitch1, "interact")
            SetTag(lightswitch2, "interact")
		else
		    for i=1, #switchMotor do
			local motor = switchMotor[i]
                SetJointMotorTarget(motor, OffSwitch, OffSpeed)
			end
	        SetTag(lightswitch1, "interact")
            SetTag(lightswitch2, "interact")
		end
    else
	    if not switchOn then
		    for i=1, #switchMotor do
			local motor = switchMotor[i]
                SetJointMotorTarget(motor, OnSwitch, OnSpeed)
			end
	        SetTag(lightswitch1, "interact")
            SetTag(lightswitch2, "interact")
		else
		    for i=1, #switchMotor do
			local motor = switchMotor[i]
                SetJointMotorTarget(motor, OffSwitch, OffSpeed)
			end
	        SetTag(lightswitch1, "interact")
            SetTag(lightswitch2, "interact")
		end
	end
	
	if not IsShapeBroken(light) then
		if GetPlayerInteractShape() == masterswitch and InputPressed("interact") then
			if lightOn then
                lightOn = false
				switchOn = false
			else
                lightOn = false
				switchOn = false
			end
		end
	else
		if GetPlayerInteractShape() == masterswitch and InputPressed("interact") then
			if lightOn then
				switchOn = false
			else
				switchOn = false
			end
		end
	end

end

