function init()
	ovenbox = FindShape("oven")
	wireplug = FindShape("wireplug")
	cable = FindJoint("cable")
	plugbox = FindTrigger("plugbox")
	ovenLight = FindLight("ovenlight")
	screen = FindScreen("timescreen")
	ovenOn = false
	bakeOn = false
	screenOn = true
	
    masterfuseMotor = FindJoints("fusemaster", true)
	masterfuse = FindShape("fusemaster", true)
	masterfuseOn = true
	
	fuse = FindShape("fusekitchen", true)
    fuseMotor = FindJoints("fusekitchen", true)
	fusebox = FindShape("fusebox", true)
	fuseOn = true
	
	snd = LoadLoop("MOD/script/oven/oven.ogg")
	
	powercable1 = FindJoint("powercable1", true)
	powercable2 = FindJoint("powercable2", true)
	powercable3 = FindJoint("powercable3", true)
	powercable4 = FindJoint("powercable4", true)
	powercable5 = FindJoint("powercable5", true)
	powercable6 = FindJoint("powercable6", true)
	powercable7 = FindJoint("powercable7", true)
	powercable8 = FindJoint("powercable8", true)
	powercable9 = FindJoint("powercable9", true)
	powercable10 = FindJoint("powercable10", true)
	powercable11 = FindJoint("powercable11", true)
	powercable12 = FindJoint("powercable12", true)
	powercable13 = FindJoint("powercable13", true)
	powercable14 = FindJoint("powercable14", true)
	powercable15 = FindJoint("powercable15", true)
	powercable16 = FindJoint("powercable16", true)
end

function tick(dt)	
	cable1 = IsJointBroken(powercable1)
	cable2 = IsJointBroken(powercable2)
	cable3 = IsJointBroken(powercable3)
	cable4 = IsJointBroken(powercable4)
	cable5 = IsJointBroken(powercable5)
	cable6 = IsJointBroken(powercable6)
	cable7 = IsJointBroken(powercable7)
	cable8 = IsJointBroken(powercable8)
	cable9 = IsJointBroken(powercable9)
	cable10 = IsJointBroken(powercable10)
	cable11 = IsJointBroken(powercable11)
	cable12 = IsJointBroken(powercable12)
	cable13 = IsJointBroken(powercable13)
	cable14 = IsJointBroken(powercable14)
	cable15 = IsJointBroken(powercable15)
	cable16 = IsJointBroken(powercable16)
	broken1 = IsShapeBroken(ovenbox)
	broken2 = IsJointBroken(cable)
	
	broken = cable1 or cable2 or cable3 or cable4 or cable5 or cable6 or cable7 or cable8 or cable9 or cable10 or cable11 or cable12 or cable13 or cable14 or cable15 or cable16 or broken1 or broken2
	
	if GetPlayerInteractShape() == masterfuse and InputPressed("interact") then
        if masterfuseOn then
			fuseOn = false
			masterfuseOn = false
	    else
			masterfuseOn = true
		end
	end	
	
	if not IsShapeBroken(fusebox) then
        if masterfuseOn then
	        SetTag(masterfuse, "interact", "turn off")
		    for i=1, #masterfuseMotor do
	        local motor = masterfuseMotor[i]
                SetJointMotorTarget(motor, -35, 5)
		    end
	    else
	        SetTag(masterfuse, "interact", "turn on")
		    for i=1, #masterfuseMotor do
	        local motor = masterfuseMotor[i]
                SetJointMotorTarget(motor, 35, 5)
		    end
	    end
	else
        if masterfuseOn then
	        SetTag(masterfuse, "interact", "broken")
		    for i=1, #masterfuseMotor do
	        local motor = masterfuseMotor[i]
                SetJointMotorTarget(motor, -35, 5)
		    end
	    else
	        SetTag(masterfuse, "interact", "broken")
		    for i=1, #masterfuseMotor do
	        local motor = masterfuseMotor[i]
                SetJointMotorTarget(motor, 35, 5)
		    end
	    end
	end	
	if masterfuseOn then
	    if GetPlayerInteractShape() == fuse and InputPressed("interact") then
            if fuseOn then
			    fuseOn = false
	        else
                fuseOn = true
		    end
	    end	
	else
	    if GetPlayerInteractShape() == fuse and InputPressed("interact") then
            if fuseOn then
			    fuseOn = false
	        else
                fuseOn = false
		    end
	    end	
	end	
	
		if GetPlayerInteractShape() == ovenbox and InputPressed("interact") then
		    if IsShapeInTrigger(plugbox, wireplug) then
			    if not ovenOn then
				    ovenOn = true
			    else
				   ovenOn = false
			    end
			end
		end
	if ovenOn and not broken then
	    local ovenBody = FindBody("oven2")
        local t = GetBodyTransform(ovenBody)
        local bodyPoint = Vec(-0.2, 0.3, -0.2)
        local ovenPosition = TransformToParentPoint(t, bodyPoint)
		PlayLoop(snd, ovenPosition, 0.3)
	end
	
	if IsShapeBroken(fusebox) and not broken then
	    if fuseOn then
		    if ovenOn then
			    bakeOn = false
			else
			    bakeOn = false
			end
			if screenOn then
			    SetScreenEnabled(screen, false)
				screenOn = false
			end
	    else
		    if ovenOn then
			    bakeOn = false
			else
			    bakeOn = false
			end
        end				
	elseif not IsShapeBroken(fusebox) and not broken then
	    if fuseOn then
		    if ovenOn then
			    bakeOn = true
			else
			    bakeOn = false
			end
			if not screenOn then
			    SetScreenEnabled(screen, true)
				screenOn = true
			end
	    else
			if screenOn then
			    SetScreenEnabled(screen, false)
				screenOn = false
			end
		    if ovenOn then
			    bakeOn = false
			else
			    bakeOn = false
			end
        end		
	end
	
	if IsShapeInTrigger(plugbox, wireplug) then	
	    if ovenOn and not broken1 then
		    SetTag(ovenbox, "interact", "Turn off")
	    elseif not ovenOn and not broken1 then
		    SetTag(ovenbox, "interact", "Turn on")
	    elseif ovenOn and broken1 then
		    RemoveTag(ovenbox,"interact")
		elseif not ovenOn and broken1 then
		    RemoveTag(ovenbox,"interact")
	    end
	else
	    if ovenOn and not broken1 then
		    SetTag(ovenbox, "interact", "Turn off")
	    elseif not ovenOn and not broken1 then
		    SetTag(ovenbox, "interact", "Turn on")
	    elseif ovenOn and broken1 then
		    RemoveTag(ovenbox,"interact")
		elseif not ovenOn and broken1 then
		    RemoveTag(ovenbox,"interact")
	    end
	end
	
	if not broken then
		if IsShapeInTrigger(plugbox, wireplug) then		
		    if not bakeOn then
			    SetLightEnabled(ovenLight, false)
		    else
			    SetLightEnabled(ovenLight, true)	
		    end
	    else
		    if bakeOn then
			    SetLightEnabled(ovenLight, false)
			else
			    SetLightEnabled(ovenLight, false)
			end
		end
	else
	    if screenOn then
		    SetScreenEnabled(screen, false)
			screenOn = false
		end
		if IsShapeInTrigger(plugbox, wireplug) then		
		    if not bakeOn then
			    SetLightEnabled(ovenLight, false)
		    else
			    SetLightEnabled(ovenLight, false)	
		    end
	    else
		    if bakeOn then
			    SetLightEnabled(ovenLight, false)
			else
			    SetLightEnabled(ovenLight, false)
			end
		end
	end
end