function init()
	lightswitch1 = FindShape("lightswitch1")
	button1 = FindShape("button1")
	button2 = FindShape("button2")
	button3 = FindShape("button3")
	button4 = FindShape("button4")
	button5 = FindShape("button5")
	button6 = FindShape("button6")
    lamp1 = FindShape("light1")
	lamp2 = FindShape("light2")
    lamp3 = FindShape("light3")
	lamp4 = FindShape("light4")
    lamp5 = FindShape("light5")
	lamp6 = FindShape("light6")
    lamp7 = FindShape("light7")
	lamp8 = FindShape("light8")
    lamp9 = FindShape("light9")
	lamp10 = FindShape("light10")
	masterswitch = FindShape("masterswitch", true)
	light1 = FindLight("light1")
	light2 = FindLight("light2")
	light3 = FindLight("light3")
	light4 = FindLight("light4")
	light5 = FindLight("light5")
	light6 = FindLight("light6")
    switch1Motor = FindJoints("switch1")
    switch2Motor = FindJoints("switch2")
    lightOn = true
    OnSwitch = GetFloatParam("OnSwitch", 2)
    OffSwitch = GetFloatParam("OffSwitch", 0)

    OnSpeed = GetFloatParam("OnSpeed", 2)
    OffSpeed =  GetFloatParam("OffSpeed", 2)
    switch1On = true
    switch2On = false
	SetTag(masterswitch, "interact")
	
	whiteOn = true
	blueOn = false
	greenOn = false
	redOn = false
	yellowOn = false
	rainbowOn = false
	SetTag(button1, "interact")
	SetTag(button2, "interact")
	SetTag(button3, "interact")
	SetTag(button4, "interact")
	SetTag(button5, "interact")
	SetTag(button6, "interact")
	
    masterfuseMotor = FindJoints("fusemaster", true)
	masterfuse = FindShape("fusemaster", true)
	masterfuseOn = true
	
    fuseMotor = FindJoints("fuseoutdoor", true)
	fusebox = FindShape("fusebox", true)
	fuse = FindShape("fuseoutdoor", true)
	fuseOn = true
	switchSound = LoadSound("MOD/script/lightswitch.ogg")
	
	powercable1 = FindJoint("powercable1", true)
	powercable2 = FindJoint("powercable2", true)
	powercable3 = FindJoint("powercable3", true)
	powercable4 = FindJoint("powercable4", true)
	powercable5 = FindJoint("powercable5", true)
	powercable6 = FindJoint("powercable6", true)
	powercable7 = FindJoint("powercable7", true)
	powercable8 = FindJoint("powercable8", true)
	powercable9 = FindJoint("powercable9", true)
	powercable10 = FindJoint("powercable10", true)
	powercable11 = FindJoint("powercable11", true)
	powercable12 = FindJoint("powercable12", true)
	powercable13 = FindJoint("powercable13", true)
	powercable14 = FindJoint("powercable14", true)
	powercable15 = FindJoint("powercable15", true)
	powercable16 = FindJoint("powercable16", true)
end

function tick(dt)	
	cable1 = IsJointBroken(powercable1)
	cable2 = IsJointBroken(powercable2)
	cable3 = IsJointBroken(powercable3)
	cable4 = IsJointBroken(powercable4)
	cable5 = IsJointBroken(powercable5)
	cable6 = IsJointBroken(powercable6)
	cable7 = IsJointBroken(powercable7)
	cable8 = IsJointBroken(powercable8)
	cable9 = IsJointBroken(powercable9)
	cable10 = IsJointBroken(powercable10)
	cable11 = IsJointBroken(powercable11)
	cable12 = IsJointBroken(powercable12)
	cable13 = IsJointBroken(powercable13)
	cable14 = IsJointBroken(powercable14)
	cable15 = IsJointBroken(powercable15)
	cable16 = IsJointBroken(powercable16)
    broken1 = IsShapeBroken(lamp1)
    broken2 = IsShapeBroken(lamp2)
    broken3 = IsShapeBroken(lamp3)
    broken4 = IsShapeBroken(lamp4)
    broken5 = IsShapeBroken(lamp5)
    broken6 = IsShapeBroken(lamp6)
	
	local r = 1 + math.sin(GetTime()*0.4)*1
	local g = 1 + math.sin(GetTime()*0.2)*1
	local b = 1 + math.sin(GetTime()*0.1)*1
	
	local switch1Transform = GetShapeWorldTransform(lightswitch1)
	local switch1Position = switch1Transform.pos
	
	if GetPlayerInteractShape() == button1 and InputPressed("interact") then
        if blueOn or redOn or greenOn or yellowOn or rainbowOn  then
			whiteOn = true
			redOn = false
			greenOn = false
			yellowOn = false
			blueOn = false
			rainbowOn = false
		end
	end
	if GetPlayerInteractShape() == button2 and InputPressed("interact") then
        if blueOn or redOn or whiteOn or yellowOn or rainbowOn  then
			blueOn = false
			whiteOn = false
			redOn = false
			yellowOn = false
			greenOn = true
			rainbowOn = false
		end
	end
	if GetPlayerInteractShape() == button3 and InputPressed("interact") then
        if greenOn or redOn or whiteOn or yellowOn or rainbowOn  then
			blueOn = true
			whiteOn = false
			redOn = false
			yellowOn = false
			greenOn = false
		    rainbowOn = false
		end
	end
	if GetPlayerInteractShape() == button4 and InputPressed("interact") then
        if greenOn or blueOn or whiteOn or yellowOn or rainbowOn  then
			blueOn = false
			whiteOn = false
			yellowOn = false
			redOn = true
			greenOn = false
			rainbowOn = false
		end
	end
	if GetPlayerInteractShape() == button5 and InputPressed("interact") then
        if greenOn or blueOn or whiteOn or redOn or rainbowOn then
			blueOn = false
			whiteOn = false
			yellowOn = true
			redOn = false
			greenOn = false
			rainbowOn = false
		end
	end
	
	if GetPlayerInteractShape() == button6 and InputPressed("interact") then
        if greenOn or blueOn or whiteOn or redOn or yellowOn then
			blueOn = false
			whiteOn = false
			yellowOn = false
			redOn = false
			greenOn = false
			rainbowOn = true
		end
	end
	
	if whiteOn then
	    SetLightColor(light1, 1,1,1)
	    SetLightColor(light2, 1,1,1)
	    SetLightColor(light3, 1,1,1)
	    SetLightColor(light4, 1,1,1)
	    SetLightColor(light5, 1,1,1)
	    SetLightColor(light6, 1,1,1)
	end	

	if rainbowOn then
	    SetLightColor(light1, r, g, b)
	    SetLightColor(light2, r, g, b)
	    SetLightColor(light3, r, g, b)
	    SetLightColor(light4, r, g, b)
	    SetLightColor(light5, r, g, b)
	    SetLightColor(light6, r, g, b)
	end	
	
	
	if yellowOn then
	    SetLightColor(light1, 1,1,0)
	    SetLightColor(light2, 1,1,0)
	    SetLightColor(light3, 1,1,0)
	    SetLightColor(light4, 1,1,0)
	    SetLightColor(light5, 1,1,0)
	    SetLightColor(light6, 1,1,0)
	end	
	
	if blueOn then
	    SetLightColor(light1, 0,0,1)
	    SetLightColor(light2, 0,0,1)
	    SetLightColor(light3, 0,0,1)
	    SetLightColor(light4, 0,0,1)
	    SetLightColor(light5, 0,0,1)
	    SetLightColor(light6, 0,0,1)
	end
	
	if greenOn then
	    SetLightColor(light1, 0,1,0)
	    SetLightColor(light2, 0,1,0)
	    SetLightColor(light3, 0,1,0)
	    SetLightColor(light4, 0,1,0)
	    SetLightColor(light5, 0,1,0)
	    SetLightColor(light6, 0,1,0)
	end
	
	if redOn then
	    SetLightColor(light1, 1,0,0)
	    SetLightColor(light2, 1,0,0)
	    SetLightColor(light3, 1,0,0)
	    SetLightColor(light4, 1,0,0)
	    SetLightColor(light5, 1,0,0)
	    SetLightColor(light6, 1,0,0)
	end
	
	if GetPlayerInteractShape() == masterfuse and InputPressed("interact") then
        if masterfuseOn then
			fuseOn = false
			masterfuseOn = false
	    else
			masterfuseOn = true
		end
	end	
	
	if not IsShapeBroken(fusebox) then
        if masterfuseOn then
	        SetTag(masterfuse, "interact", "turn off")
		    for i=1, #masterfuseMotor do
	        local motor = masterfuseMotor[i]
                SetJointMotorTarget(motor, -35, 5)
		    end
	    else
	        SetTag(masterfuse, "interact", "turn on")
		    for i=1, #masterfuseMotor do
	        local motor = masterfuseMotor[i]
                SetJointMotorTarget(motor, 35, 5)
		    end
	    end
	else
        if masterfuseOn then
	        SetTag(masterfuse, "interact", "broken")
		    for i=1, #masterfuseMotor do
	        local motor = masterfuseMotor[i]
                SetJointMotorTarget(motor, -35, 5)
		    end
	    else
	        SetTag(masterfuse, "interact", "broken")
		    for i=1, #masterfuseMotor do
	        local motor = masterfuseMotor[i]
                SetJointMotorTarget(motor, 35, 5)
		    end
	    end
	end	
	if masterfuseOn then
	    if GetPlayerInteractShape() == fuse and InputPressed("interact") then
            if fuseOn then
			    fuseOn = false
	        else
                fuseOn = true
		    end
	    end	
	else
	    if GetPlayerInteractShape() == fuse and InputPressed("interact") then
            if fuseOn then
			    fuseOn = false
	        else
                fuseOn = false
		    end
	    end	
	end
	
	if not IsShapeBroken(fusebox) then
        if fuseOn then
	        SetTag(fuse, "interact", "turn off")
		    for i=1, #fuseMotor do
	        local motor = fuseMotor[i]
                SetJointMotorTarget(motor, -35, 5)
		    end
	    else
	        SetTag(fuse, "interact", "turn on")
		    for i=1, #fuseMotor do
	        local motor = fuseMotor[i]
                SetJointMotorTarget(motor, 35, 5)
		    end
	    end
	else
        if fuseOn then
	        SetTag(fuse, "interact", "broken")
		    for i=1, #fuseMotor do
	        local motor = fuseMotor[i]
                SetJointMotorTarget(motor, -35, 5)
		    end
	    else
	        SetTag(fuse, "interact", "broken")
		    for i=1, #fuseMotor do
	        local motor = fuseMotor[i]
                SetJointMotorTarget(motor, 35, 5)
		    end
	    end
    end
	
    if GetPlayerInteractShape() == lightswitch1 and InputPressed("interact") then
	    if switch1On then
		    switch1On = false
	    else
		    switch1On = true
		end
		PlaySound(switchSound, switch1Position, 1)
	end
	
	if IsShapeBroken(fusebox) then
	    if fuseOn then
		    if switch1On then
			    lightOn = false
			else
			    lightOn = false
			end
	    else
		    if switch1On then
			    lightOn = false
			else
			    lightOn = false
			end
        end				
	else
		if fuseOn then
	        if switch1On then
		        lightOn = true
		    else
		        lightOn = false
		    end
	    else
	        if switch1On then
		        lightOn = false
		    else
		        lightOn = false
		    end
		end
	end
	
	if not IsShapeBroken(lamp1) and not cable1 and not cable2 and not cable3 and not cable4 and not cable5 and not cable6 and not cable7 and not cable8 and not cable9 and not cable10 and not cable11 and not cable12 and not cable13 and not cable14 and not cable15 and not cable16 then
	    if lightOn then
		     SetLightEnabled(light1, true)
	    else
		    SetLightEnabled(light1, false)
	    end
	else
	    if lightOn then
		     SetLightEnabled(light1, false)
	    else
		    SetLightEnabled(light1, false)
	    end
	end
	
	if not IsShapeBroken(lamp2) and not cable1 and not cable2 and not cable3 and not cable4 and not cable5 and not cable6 and not cable7 and not cable8 and not cable9 and not cable10 and not cable11 and not cable12 and not cable13 and not cable14 and not cable15 and not cable16 then
	    if lightOn then
		     SetLightEnabled(light2, true)
	    else
		    SetLightEnabled(light2, false)
	    end
	else
	    if lightOn then
		     SetLightEnabled(light2, false)
	    else
		    SetLightEnabled(light2, false)
	    end
	end
	
	if not IsShapeBroken(lamp3) and not cable1 and not cable2 and not cable3 and not cable4 and not cable5 and not cable6 and not cable7 and not cable8 and not cable9 and not cable10 and not cable11 and not cable12 and not cable13 and not cable14 and not cable15 and not cable16 then
	    if lightOn then
		     SetLightEnabled(light3, true)
	    else
		    SetLightEnabled(light3, false)
	    end
	else
	    if lightOn then
		     SetLightEnabled(light3, false)
	    else
		    SetLightEnabled(light3, false)
	    end
	end

	if not IsShapeBroken(lamp4) and not cable1 and not cable2 and not cable3 and not cable4 and not cable5 and not cable6 and not cable7 and not cable8 and not cable9 and not cable10 and not cable11 and not cable12 and not cable13 and not cable14 and not cable15 and not cable16 then
	    if lightOn then
		     SetLightEnabled(light4, true)
	    else
		    SetLightEnabled(light4, false)
	    end
	else
	    if lightOn then
		     SetLightEnabled(light4, false)
	    else
		    SetLightEnabled(light4, false)
	    end
	end
	
	if not IsShapeBroken(lamp5) and not cable1 and not cable2 and not cable3 and not cable4 and not cable5 and not cable6 and not cable7 and not cable8 and not cable9 and not cable10 and not cable11 and not cable12 and not cable13 and not cable14 and not cable15 and not cable16 then
	    if lightOn then
		     SetLightEnabled(light5, true)
	    else
		    SetLightEnabled(light5, false)
	    end
	else
	    if lightOn then
		     SetLightEnabled(light5, false)
	    else
		    SetLightEnabled(light5, false)
	    end
	end
	
	if not IsShapeBroken(lamp6) and not cable1 and not cable2 and not cable3 and not cable4 and not cable5 and not cable6 and not cable7 and not cable8 and not cable9 and not cable10 and not cable11 and not cable12 and not cable13 and not cable14 and not cable15 and not cable16 then
	    if lightOn then
		     SetLightEnabled(light6, true)
	    else
		    SetLightEnabled(light6, false)
	    end
	else
	    if lightOn then
		     SetLightEnabled(light6, false)
	    else
		    SetLightEnabled(light6, false)
	    end
	end

	if not IsShapeBroken(light) then
	    if not switch1On then
		    for i=1, #switch1Motor do
			local motor1 = switch1Motor[i]
                SetJointMotorTarget(motor1, OnSwitch, OnSpeed)
			end
	        SetTag(lightswitch1, "interact")
		else
		    for i=1, #switch1Motor do
			local motor1 = switch1Motor[i]
                SetJointMotorTarget(motor1, OffSwitch, OffSpeed)
			end
	        SetTag(lightswitch1, "interact")
		end
    else
	    if not switch1On then
		    for i=1, #switch1Motor do
			local motor1 = switch1Motor[i]
                SetJointMotorTarget(motor1, OnSwitch, OnSpeed)
			end
	        SetTag(lightswitch1, "interact")
		else
		    for i=1, #switch1Motor do
			local motor1 = switch1Motor[i]
                SetJointMotorTarget(motor1, OffSwitch, OffSpeed)
			end
	        SetTag(lightswitch1, "interact")
		end
	end
	
	if not IsShapeBroken(light) then
	    if not switch2On then
		    for i=1, #switch2Motor do
			local motor2 = switch2Motor[i]
                SetJointMotorTarget(motor2, OnSwitch, OnSpeed)
			end
            SetTag(lightswitch2, "interact")
		else
		    for i=1, #switch2Motor do
			local motor2 = switch2Motor[i]
                SetJointMotorTarget(motor2, OffSwitch, OffSpeed)
			end
            SetTag(lightswitch2, "interact")
		end
    else
	    if not switch2On then
		    for i=1, #switch2Motor do
			local motor2 = switch2Motor[i]
                SetJointMotorTarget(motor2, OnSwitch, OnSpeed)
			end
            SetTag(lightswitch2, "interact")
		else
		    for i=1, #switch2Motor do
			local motor2 = switch2Motor[i]
                SetJointMotorTarget(motor2, OffSwitch, OffSpeed)
			end
            SetTag(lightswitch2, "interact")
		end
	end
	
	if broken1 then
		if GetPlayerInteractShape() == masterswitch and InputPressed("interact") then
			if lightOn then
                lightOn = false
				switch1On = false
			else
                lightOn = false
				switch1On = false
			end
		end
	else
		if GetPlayerInteractShape() == masterswitch and InputPressed("interact") then
			if lightOn then
				switch1On = false
			else
				switch1On = false
			end
		end
	end
	
	if broken2 then
		if GetPlayerInteractShape() == masterswitch and InputPressed("interact") then
			if lightOn then
                lightOn = false
				switch1On = false
			else
                lightOn = false
				switch1On = false
			end
		end
	else
		if GetPlayerInteractShape() == masterswitch and InputPressed("interact") then
			if lightOn then
				switch1On = false
			else
				switch1On = false
			end
		end
	end
	
	if broken3 then
		if GetPlayerInteractShape() == masterswitch and InputPressed("interact") then
			if lightOn then
                lightOn = false
				switch1On = false
			else
                lightOn = false
				switch1On = false
			end
		end
	else
		if GetPlayerInteractShape() == masterswitch and InputPressed("interact") then
			if lightOn then
				switch1On = false
			else
				switch1On = false
			end
		end
	end
	
	if broken4 then
		if GetPlayerInteractShape() == masterswitch and InputPressed("interact") then
			if lightOn then
                lightOn = false
				switch1On = false
			else
                lightOn = false
				switch1On = false
			end
		end
	else
		if GetPlayerInteractShape() == masterswitch and InputPressed("interact") then
			if lightOn then
				switch1On = false
			else
				switch1On = false
			end
		end
	end
	
	if broken5 then
		if GetPlayerInteractShape() == masterswitch and InputPressed("interact") then
			if lightOn then
                lightOn = false
				switch1On = false
			else
                lightOn = false
				switch1On = false
			end
		end
	else
		if GetPlayerInteractShape() == masterswitch and InputPressed("interact") then
			if lightOn then
				switch1On = false
			else
				switch1On = false
			end
		end
	end
	
	if broken6 then
		if GetPlayerInteractShape() == masterswitch and InputPressed("interact") then
			if lightOn then
                lightOn = false
				switch1On = false
			else
                lightOn = false
				switch1On = false
			end
		end
	else
		if GetPlayerInteractShape() == masterswitch and InputPressed("interact") then
			if lightOn then
				switch1On = false
			else
				switch1On = false
			end
		end
	end


end

