function init()
    dlock1 = FindShape("lock1")
    dlock2 = FindShape("lock2")
    dlock3 = FindShape("lock3")
    dlock4 = FindShape("lock4")
	
    framelock1 = FindShape("slideframelock1")
    framelock2 = FindShape("slideframelock2")
    framelock3 = FindShape("slideframelock3")
    framelock4 = FindShape("slideframelock4")
	
    motors1 = FindJoints("motor1")
    motors2 = FindJoints("motor2")
    motors3 = FindJoints("motor3")
    motors4 = FindJoints("motor4")
	
	sdoor1 = FindShape("slidedoor1")
	sdoor2 = FindShape("slidedoor2")
	sdoor3 = FindShape("slidedoor3")
	sdoor4 = FindShape("slidedoor4")
	
	door1 = FindTrigger("doortrigger1")
	door2 = FindTrigger("doortrigger2")
	door3 = FindTrigger("doortrigger3")
	door4 = FindTrigger("doortrigger4")
	
    dmotor1 = FindJoint("lockmotor1")
    dmotor2 = FindJoint("lockmotor2")
    dmotor3 = FindJoint("lockmotor3")
    dmotor4 = FindJoint("lockmotor4")
	
	SetBool("level.doorlock1", true)
	SetBool("level.doorlock2", true)
	SetBool("level.doorlock3", true)
	SetBool("level.doorlock4", true)
    

end

function tick(dt)
	framebroken1 = IsShapeBroken(framelock1)
	framebroken2 = IsShapeBroken(framelock2)
	framebroken3 = IsShapeBroken(framelock3)
	framebroken4 = IsShapeBroken(framelock4)
	
	doorbroken1 = IsShapeBroken(dlock1)
	doorbroken2 = IsShapeBroken(dlock2)
	doorbroken3 = IsShapeBroken(dlock3)
	doorbroken4 = IsShapeBroken(dlock4)
	
	local doorlocked1 = GetBool("level.doorlock1")
	local doorlocked2 = GetBool("level.doorlock2")
	local doorlocked3 = GetBool("level.doorlock3")
	local doorlocked4 = GetBool("level.doorlock4")


    SetTag(dlock1, "interact")
    SetTag(dlock2, "interact")
    SetTag(dlock3, "interact")
    SetTag(dlock4, "interact")

	if IsShapeInTrigger(door1, sdoor1) then
	    if GetPlayerInteractShape() == dlock1 and InputPressed("interact") then
	        if not doorlocked1 then
		        SetBool("level.doorlock1", true)
	        else
		        SetBool("level.doorlock1", false)
			end
	    end
	end
	
	if IsShapeInTrigger(door2, sdoor2) then
	    if GetPlayerInteractShape() == dlock2 and InputPressed("interact") then
	        if not doorlocked2 then
		        SetBool("level.doorlock2", true)
	        else
		        SetBool("level.doorlock2", false)
			end
	    end
	end
	
	if IsShapeInTrigger(door3, sdoor3) then
	    if GetPlayerInteractShape() == dlock3 and InputPressed("interact") then
	        if not doorlocked3 then
		        SetBool("level.doorlock3", true)
	        else
		        SetBool("level.doorlock3", false)
			end
	    end
	end
	
	if IsShapeInTrigger(door4, sdoor4) then
	    if GetPlayerInteractShape() == dlock4 and InputPressed("interact") then
	        if not doorlocked4 then
		        SetBool("level.doorlock4", true)
	        else
		        SetBool("level.doorlock4", false)
			end
	    end
	end
	if GetString("game.player.tool") == "key" then
	    if InputPressed("usetool") then
		        SetBool("level.doorlock1", true)
		        SetBool("level.doorlock2", true)
		        SetBool("level.doorlock3", true)
		        SetBool("level.doorlock4", true)
		end
	end
	
	if not doorbroken1 or not framebroken1 then
	    if doorlocked1 then
            for i=1,#motors1 do
                local motor1 = motors1[i]
                SetJointMotorTarget(motor1, 0, 10)
            end
			SetJointMotorTarget(dmotor1, 0, 10, 1000)
	    else
            for i=1,#motors1 do
                local motor1 = motors1[i]
                SetJointMotorTarget(motor1, 0, 0, 0)
			end
			SetJointMotorTarget(dmotor1, 90, 10, 1000)
        end
	end
	
	if not doorbroken2 or not framebroken2 then
	    if doorlocked2 then
            for i=1,#motors2 do
                local motor2 = motors2[i]
                SetJointMotorTarget(motor2, 0, 10)
            end
			SetJointMotorTarget(dmotor2, 0, 10, 1000)
	    else
            for i=1,#motors2 do
                local motor2 = motors2[i]
                SetJointMotorTarget(motor2, 0, 0, 0)
			end
			SetJointMotorTarget(dmotor2, 90, 10, 1000)
        end
	end
	
	if not doorbroken3 or not framebroken3 then
	    if doorlocked3 then
            for i=1,#motors3 do
                local motor3 = motors3[i]
                SetJointMotorTarget(motor3, 0, 10)
            end
			SetJointMotorTarget(dmotor3, 0, 10, 1000)
	    else
            for i=1,#motors3 do
                local motor3 = motors3[i]
                SetJointMotorTarget(motor3, 0, 0, 0)
			end
			SetJointMotorTarget(dmotor3, 90, 10, 1000)
        end
	end
	
	if not doorbroken4 or not framebroken4 then
	    if doorlocked4 then
            for i=1,#motors4 do
                local motor4 = motors4[i]
                SetJointMotorTarget(motor4, 0, 10)
            end
			SetJointMotorTarget(dmotor4, 0, 10, 1000)
	    else
            for i=1,#motors4 do
                local motor4 = motors4[i]
                SetJointMotorTarget(motor4, 0, 0, 0)
			end
			SetJointMotorTarget(dmotor4, 90, 10, 1000)
        end
	end
	
	if doorbroken1 or framebroken1 then
	    if doorlocked1 then
            for i=1,#motors1 do
                local motor1 = motors1[i]
                SetJointMotorTarget(motor1, 0, 0, 0)
            end
	    else
            for i=1,#motors1 do
                local motor1 = motors1[i]
                SetJointMotorTarget(motor1, 0, 0, 0)
			end
        end
	end
	
	if doorbroken2 or framebroken2 then
	    if doorlocked2 then
            for i=1,#motors2 do
                local motor2 = motors2[i]
                SetJointMotorTarget(motor2, 0, 0, 0)
            end
	    else
            for i=1,#motors2 do
                local motor2 = motors2[i]
                SetJointMotorTarget(motor2, 0, 0, 0)
			end
        end
	end
	
	if doorbroken3 or framebroken3 then
	    if doorlocked3 then
            for i=1,#motors3 do
                local motor3 = motors3[i]
                SetJointMotorTarget(motor3, 0, 0, 0)
            end
	    else
            for i=1,#motors3 do
                local motor3 = motors3[i]
                SetJointMotorTarget(motor3, 0, 0, 0)
			end
        end
	end
	
	if doorbroken4 or framebroken4 then
	    if doorlocked4 then
            for i=1,#motors4 do
                local motor4 = motors4[i]
                SetJointMotorTarget(motor4, 0, 0, 0)
            end
	    else
            for i=1,#motors4 do
                local motor4 = motors4[i]
                SetJointMotorTarget(motor4, 0, 0, 0)
			end
        end
	end

end