function init()
	tv = FindShape("tv")
	screen = FindScreen("screen")
	
	tvLight = FindLight("tv")
	tvOn = true
end

function tick(dt)
	broken = IsShapeBroken(tv)
	
	if not broken then
		if GetPlayerInteractShape() == tv and InputPressed("interact") then
			if not tvOn then
				SetScreenEnabled(screen, true)
				tvOn = true
			else
				SetScreenEnabled(screen, false)
				tvOn = false
			end
		end
		
		if not tvOn then
			SetTag(tv, "interact", "Turn on")
			SetLightEnabled(tvLight, false)
		else
			SetTag(tv, "interact", "Turn off")
			SetLightEnabled(tvLight, true)
		end
	else
		RemoveTag(tv, "interact")
	end
end