    defaults = {
        night = true;
	}
function init()
    modOptions = "savegame.mod.stars"
end
function tick()
	if PauseMenuButton("Modes") then
		visible = true
	end
	if InputPressed("rmb") then
	    visible = false
	end

end
function getModOptions(GetFunction, Key)
	if  HasKey(modOptions .. "." .. Key) then
		return GetFunction(modOptions .. "." .. Key)
	else
		return nil
	end
end

function setModOptions(SetFunction, Key, value)
	SetFunction(modOptions .. "." .. Key, value)
end

function runOptionDefaults(overWriteDefaultsValues)
	for i,v in pairs(defaults) do
		if not HasKey(modOptions .. "." .. i) or overWriteDefaultsValues then
			local t = type(v)
			local setCall = nil
			if t == "boolean" then
				setCall = SetBool
			elseif t == "number" then
				setCall = SetFloat
			elseif t == "string" then
				setCall = SetString
			end
			setCall(modOptions.."."..i, v)
		end
	end
end
function draw()
	if visible then
		UiMakeInteractive()
		UiPush()
		    UiTranslate(380, 100)
		    UiColor(0.2, 0.2, 0.2)
		    UiRect(220, 50)
			
			UiTranslate(110, 25)
		    UiFont("bold.ttf", 32)
		    UiColor(1, 1, 1)
		    UiAlign('center middle')
		    UiText("Normal Version")
			UiTranslate(0, 180)
			UiScale(0.2)
			if UiImageButton("MOD/script/pics/normal.png") then
			    StartLevel("", "main.xml")
			end
		UiPop()
		UiPush()
            UiTranslate(340, 500)
		    UiColor(0.2, 0.2, 0.2)
		    UiRect(300, 50)
			
			UiTranslate(150, 25)
		    UiFont("bold.ttf", 32)
		    UiColor(1, 1, 1)
		    UiAlign('center middle')
		    UiText("Performance Version")
			UiTranslate(0, 180)
			UiScale(0.2)
			if UiImageButton("MOD/script/pics/performance.png") then
			    StartLevel("", "performance.xml")
			end
		UiPop()
		
		UiPush()
		    UiTranslate(880, 100)
		    UiColor(0.2, 0.2, 0.2)
		    UiRect(280, 50)
			
			UiTranslate(140, 25)
		    UiFont("bold.ttf", 32)
		    UiColor(1, 1, 1)
		    UiAlign('center middle')
		    UiText("Snow Normal Version")
			UiTranslate(0, 180)
			UiScale(0.2)
			if UiImageButton("MOD/script/pics/normalsnow.png") then
			    StartLevel("", "normalsnow.xml")
			end
		UiPop()
		UiPush()
            UiTranslate(840, 500)
		    UiColor(0.2, 0.2, 0.2)
		    UiRect(360, 50)
			
			UiTranslate(180, 25)
		    UiFont("bold.ttf", 32)
		    UiColor(1, 1, 1)
		    UiAlign('center middle')
		    UiText("Snow Performance Version")
			UiTranslate(0, 180)
			UiScale(0.2)
			if UiImageButton("MOD/script/pics/performancesnow.png") then
			    StartLevel("", "performancesnow.xml")
			end
		UiPop()
		UiPush()
		    UiTranslate(1380, 100)
		    UiColor(0.2, 0.2, 0.2)
		    UiRect(280, 50)
			
			UiTranslate(140, 25)
		    UiFont("bold.ttf", 32)
		    UiColor(1, 1, 1)
		    UiAlign('center middle')
			if getModOptions(GetBool, "night") == true then
			    UiText("Stars on")
			end
			if getModOptions(GetBool, "night") == false then
			    UiText("Stars off")
			end
			UiTranslate(0, 180)
			UiScale(0.2)
			if getModOptions(GetBool, "night") == true then
			    if UiImageButton("MOD/script/pics/stars.png") then
			        setModOptions(SetBool, "night", not getModOptions(GetBool, "night"))
				    Restart()
			    end
			end
			if getModOptions(GetBool, "night") == false then
			    if UiImageButton("MOD/script/pics/nostars.png") then
			        setModOptions(SetBool, "night", not getModOptions(GetBool, "night"))
				    Restart()
			    end
			end
		UiPop()
		UiPush()
            UiTranslate(1380, 500)
			
			UiTranslate(180, 25)
		    UiFont("bold.ttf", 32)
		    UiColor(1, 1, 1)
		    UiAlign('center middle')
			UiTranslate(0, 180)
			UiScale(2)
			if UiTextButton("Reset") then
			    runOptionDefaults(true)
			end
		UiPop()
	end
end

