function init()
	workout = false
	timer = 0
end

function tick(dt)


	bench = FindBody("benchpress")
	benchTrans = GetBodyTransform(bench)
	benchTransPosition = benchTrans.pos
	benchTransRotation = benchTrans.rot
	benchPoint = Vec(0.05, 0.8, -0.7)
    lockPoint = TransformToParentPoint(benchTrans, benchPoint)
	SetTag(bench, "interact", "workout")
	dir = TransformToParentVec(benchTrans, Vec(0,1,0))
	origin = VecCopy(lockPoint)
	QueryRejectBody(bench)
	hit, dist, normal = QueryRaycast(origin, dir, 1)	
	endPoint = VecAdd(origin, VecScale(dir, dist))
	
	test = benchTransRotation[2]*100
	rx, ry, rz = GetQuatEuler(benchTransRotation)
	DebugCross(lockPoint)
	DrawLine(lockPoint, endPoint, 1, 0, 0)
	
	DebugWatch("benchTransRotation",benchTransRotation)
	DebugWatch("test",test)
	DebugWatch("rx",rx)
	DebugWatch("ry",ry)
	DebugWatch("rz",rz)
	
	if GetPlayerInteractBody() == bench and InputPressed("interact") then
		if workout == false then
			workout = true
		end
	end
	if workout == true then
	    timer = timer + dt
	end
	if timer >= 0.1 then
		timer = 0.1
	end
	if workout == true and InputPressed("e") and timer == 0.1 then
		workout = false
		timer = 0
	end
	if workout == true then
		SetCameraTransform(Transform(Vec(lockPoint[1], lockPoint[2], lockPoint[3]), QuatEuler(rx+90,ry-180,rz)), 130)
		SetBool("game.input.locktool", true)
        SetBool("game.disablemap", true)
	end

end
