
function tick(dt)	

    mainMenu = GetBool("level.mainmenu")
    alarmboxesMenu = GetBool("level.alarmboxesMenu")

    Up1 = GetBool("level.Up1")
    Up2 = GetBool("level.Up2")
    Up3 = GetBool("level.Up3")
	
	Box1 = GetBool("level.Box1")
	Box2 = GetBool("level.Box2")
	Box3 = GetBool("level.Box3")
	Box4 = GetBool("level.Box4")
	Box5 = GetBool("level.Box5")
	Box6 = GetBool("level.Box6")
	Box7 = GetBool("level.Box7")
	Box8 = GetBool("level.Box8")
	
    on = GetBool("level.alarmOn")
    off = GetBool("level.alarmOff")

end


function draw()
    UiTranslate(UiCenter(), UiMiddle())
	UiAlign("center middle")
	UiImage("MOD/sprites/Firealarm/screen.png")
	
	-- MainMenu --
    if mainMenu then
        UiPush()
	        UiTranslate(-70,-60)
		    UiScale(0.4)
		    UiImage("MOD/sprites/Firealarm/alarm.png")
	    UiPop()
        UiPush()
	        UiTranslate(-15,-30)
		    UiScale(0.4)
		    UiImage("MOD/sprites/Firealarm/box.png")
	    UiPop()
        UiPush()
	        UiTranslate(-48,0)
		    UiScale(0.4)
		    UiImage("MOD/sprites/Firealarm/resetalarm.png")
	    UiPop()
	end
	
    if mainMenu then
        UiPush()
	        UiTranslate(-320,-200)
		    UiScale(0.4)
		    UiImage("MOD/sprites/Firealarm/alarm.png")

	    UiPop()
	end
	
    UiPush()
	    if on and mainMenu then
		    UiPush()
	            UiTranslate(-6,-57.5)
		        UiScale(0.4)
		        UiImage("MOD/sprites/Firealarm/on.png")
			UiPop()
        end
	UiPop()

    UiPush()
	    if off and mainMenu then
		    UiPush()
	            UiTranslate(-5,-60)
		        UiScale(0.4)
		        UiImage("MOD/sprites/Firealarm/off.png")
			UiPop()
        end
	UiPop()	
	
	UiPush()
		if Up1 then
            UiTranslate(-52,-60)
	        transparentbackground(127, 30,  { 0, 0, 0, 0.1 })
		end	
	UiPop()
	
	UiPush()
		if Up2 then
            UiTranslate(-15,-30)
	        transparentbackground(200, 30,  { 0, 0, 0, 0.1 })
		end
	UiPop()
	UiPush()
		if Up3 then
            UiTranslate(-48,0)
	        transparentbackground(135, 30,  { 0, 0, 0, 0.1 })
		end
	UiPop()
	
	-- BoxMenu --
	
	if alarmboxesMenu then
        UiPush()
	        UiTranslate(-80,-70)
		    UiScale(0.3)
		    UiImage("MOD/sprites/Firealarm/entrance.png")
	    UiPop()
        UiPush()
	        UiTranslate(-75,-50)
		    UiScale(0.3)
		    UiImage("MOD/sprites/Firealarm/guestbath.png")
	    UiPop()
        UiPush()
	        UiTranslate(-81,-30)
		    UiScale(0.3)
		    UiImage("MOD/sprites/Firealarm/hallway1.png")
	    UiPop()
        UiPush()
	        UiTranslate(-79,-10)
		    UiScale(0.3)
		    UiImage("MOD/sprites/Firealarm/hallway2.png")
	    UiPop()
        UiPush()
	        UiTranslate(-86,10)
		    UiScale(0.3)
		    UiImage("MOD/sprites/Firealarm/kitchen.png")
	    UiPop()
        UiPush()
	        UiTranslate(-73,32)
		    UiScale(0.3)
		    UiImage("MOD/sprites/Firealarm/livingroom.png")
	    UiPop()
        UiPush()
	        UiTranslate(-79,50)
		    UiScale(0.3)
		    UiImage("MOD/sprites/Firealarm/bedroom.png")
	    UiPop()
        UiPush()
	        UiTranslate(-77,70)
		    UiScale(0.3)
		    UiImage("MOD/sprites/Firealarm/mainbath.png")
	    UiPop()
		
	    if Box1 then
	        UiPush()
	            UiTranslate(30,-70)
		        UiScale(0.3)
		        UiImage("MOD/sprites/Firealarm/connected.png")
	        UiPop()
	    else
	        UiPush()
	            UiTranslate(42,-70)
		        UiScale(0.3)
		        UiImage("MOD/sprites/Firealarm/disconnected.png")
	        UiPop()
		end
		
	    if Box2 then
	        UiPush()
	            UiTranslate(30,-50)
		        UiScale(0.3)
		        UiImage("MOD/sprites/Firealarm/connected.png")
	        UiPop()
	    else
	        UiPush()
	            UiTranslate(42,-50)
		        UiScale(0.3)
		        UiImage("MOD/sprites/Firealarm/disconnected.png")
	        UiPop()
		end
		
	    if Box3 then
	        UiPush()
	            UiTranslate(30,-30)
		        UiScale(0.3)
		        UiImage("MOD/sprites/Firealarm/connected.png")
	        UiPop()
	    else
	        UiPush()
	            UiTranslate(42,-30)
		        UiScale(0.3)
		        UiImage("MOD/sprites/Firealarm/disconnected.png")
	        UiPop()
		end
		
		if Box4 then
	        UiPush()
	            UiTranslate(30,-10)
		        UiScale(0.3)
		        UiImage("MOD/sprites/Firealarm/connected.png")
	        UiPop()
	    else
	        UiPush()
	            UiTranslate(42,-10)
		        UiScale(0.3)
		        UiImage("MOD/sprites/Firealarm/disconnected.png")
	        UiPop()
		end
		
		if Box5 then
	        UiPush()
	            UiTranslate(30,10)
		        UiScale(0.3)
		        UiImage("MOD/sprites/Firealarm/connected.png")
	        UiPop()
	    else
	        UiPush()
	            UiTranslate(42,10)
		        UiScale(0.3)
		        UiImage("MOD/sprites/Firealarm/disconnected.png")
	        UiPop()
		end
		
		if Box6 then
	        UiPush()
	            UiTranslate(30,30)
		        UiScale(0.3)
		        UiImage("MOD/sprites/Firealarm/connected.png")
	        UiPop()
	    else
	        UiPush()
	            UiTranslate(42,30)
		        UiScale(0.3)
		        UiImage("MOD/sprites/Firealarm/disconnected.png")
	        UiPop()
		end
		
		if Box7 then
	        UiPush()
	            UiTranslate(30,50)
		        UiScale(0.3)
		        UiImage("MOD/sprites/Firealarm/connected.png")
	        UiPop()
	    else
	        UiPush()
	            UiTranslate(42,50)
		        UiScale(0.3)
		        UiImage("MOD/sprites/Firealarm/disconnected.png")
	        UiPop()
		end
		
		if Box8 then
	        UiPush()
	            UiTranslate(30,70)
		        UiScale(0.3)
		        UiImage("MOD/sprites/Firealarm/connected.png")
	        UiPop()
	    else
	        UiPush()
	            UiTranslate(42,70)
		        UiScale(0.3)
		        UiImage("MOD/sprites/Firealarm/disconnected.png")
	        UiPop()
		end
	end

end

function UiColour(c)
    UiColor(c[1], c[2], c[3], c[4])
end
function transparentbackground(w, h, buttonColourHover)

    
    UiPush()

        buttonColour = buttonColourHover


        UiColour(buttonColour)
        UiRect(w, h)
        UiTranslate(w / 2, h / 2)
        UiAlign("center middle")
    UiPop()
end