function init()
    watercold = FindShape("coldwater")
    outdoor = FindShape("outdoortap")
    watercoldhandle = FindJoint("coldwaterhandle")
    light = FindLight("waterlightoutdoortap", true)
	
    OnSwitch = GetFloatParam("OnSwitch", 2)
    OffSwitch = GetFloatParam("OffSwitch", 0)

    OnSpeed = GetFloatParam("OnSpeed", 2)
    OffSpeed =  GetFloatParam("OffSpeed", 2)
    waterOn = false
end

function tick(dt)
	broken = IsShapeBroken(outdoor)

    if not broken then

        if GetPlayerInteractShape() == watercold and InputPressed("interact") then
		    if not waterOn then
 
			    waterOn = true
	     	else

		    waterOn = false
	    	end
	    end
		
    		if waterOn then
    		    SetTag(watercold, "interact")
    			SetLightEnabled(light, true)
                SetJointMotorTarget(watercoldhandle, OnSwitch, OnSpeed)
     	        ParticleReset()
                ParticleType(smoke)
	            ParticleTile(1)
		        ParticleRadius(0.03, 0.01)
	            ParticleColor(0.9, 0.9, 1.0)
                ParticleGravity(-0.1)
			    ParticleCollide(0, 0.5)
	            for i=1,1 do
		            SpawnParticle(Vec(-2.85, 1.29, -1.65), Vec(0.0, -1.2, 0.0), 10)
		        end
		    else
			    SetTag(watercold, "interact")
			    SetLightEnabled(light, false)
                SetJointMotorTarget(watercoldhandle, OffSwitch, OffSpeed)

	        end
	else
	    SetLightEnabled(light, false)	
		RemoveTag(watercold, "interact")
	end	 
    
end


