function init()
    glass = FindShape("open")
    motors = FindJoints("motor1")
	SetTag(glass, "interact")
    firestart = FindShape("firestarter")
	SetTag(firestart, "interact")
    open = false

	ftrigger = FindTrigger("firetrigger")
	
	woodIn1 = false
	woodIn2 = false
	woodIn3 = false
	woodIn4 = false
	woodIn5 = false
	
	fireOn1 = false
	fireOn2 = false
	fireOn3 = false
	fireOn4 = false
	fireOn5 = false
	
	woodfireOn1 = false
	woodfireOn2 = false
	woodfireOn3 = false
	woodfireOn4 = false
	woodfireOn5 = false
	
	woodtimer1 = 0
	woodtimer2 = 0
	woodtimer3 = 0
	woodtimer4 = 0
	woodtimer5 = 0
	
	extinguishertimer = 0
	
	fire = LoadLoop("MOD/script/fireplace/fire.ogg")
	
	w1light1 = FindLight("wood1light1")
	w1light2 = FindLight("wood1light2")
	w2light1 = FindLight("wood2light1")
	w2light2 = FindLight("wood2light2")
	w3light1 = FindLight("wood3light1")
	w3light2 = FindLight("wood3light2")
	w4light1 = FindLight("wood4light1")
	w4light2 = FindLight("wood4light2")
	w5light1 = FindLight("wood5light1")
	w5light2 = FindLight("wood5light2")
	
	InWater1 = false
	InWater2 = false
	InWater3 = false
	InWater4 = false
	InWater5 = false
end

function tick(dt)
    local firepit = FindBody("fireplace")
    local t = GetBodyTransform(firepit)
    local bodyPoint = Vec(0, 0.7, 0.05)
    firePos = TransformToParentPoint(t, bodyPoint)
	
	fwood1 = FindBody("firewood1")
	fwood2 = FindBody("firewood2")
	fwood3 = FindBody("firewood3")
	fwood4 = FindBody("firewood4")
	fwood5 = FindBody("firewood5")
	
	WoodBody1 = GetBodyTransform(fwood1)
	WoodBody2 = GetBodyTransform(fwood2)
	WoodBody3 = GetBodyTransform(fwood3)
	WoodBody4 = GetBodyTransform(fwood4)
	WoodBody5 = GetBodyTransform(fwood5)
	
    woodbodyPoint1 = Vec(0, 0.1, 0)
    woodbodyPoint2 = Vec(0, 0.1, 0.1)
    woodbodyPoint3 = Vec(0, 0.1, -0.1)
	-- sides --
    woodbodyFirePoint1 = Vec(0, -0.01, 0)
    woodbodyFirePoint2 = Vec(0, 0.21, 0)
    woodbodyFirePoint3 = Vec(0.11, 0.1, 0)
    woodbodyFirePoint4 = Vec(-0.11, 0.1, 0)
    woodbodyFirePoint5 = Vec(0, 0.1, 0.21)
    woodbodyFirePoint6 = Vec(0, 0.1, -0.21)
	-- corners1 --
    woodbodyFirePoint7 = Vec(0.11, -0.01, 0.21)
    woodbodyFirePoint8 = Vec(-0.11, -0.01, 0.21)
    woodbodyFirePoint9 = Vec(0.11, -0.01, -0.21)
    woodbodyFirePoint10 = Vec(-0.11, -0.01, -0.21)
	-- corners2 --
    woodbodyFirePoint11 = Vec(0.11, 0.21, 0.21)
    woodbodyFirePoint12 = Vec(-0.11, 0.21, 0.21)
    woodbodyFirePoint13 = Vec(0.11, 0.21, -0.21)
    woodbodyFirePoint14 = Vec(-0.11, 0.21, -0.21)
	


	
	
	-- firewood1 --
    WoodBody1Pos1 = TransformToParentPoint(WoodBody1, woodbodyPoint1)
    WoodBody1Pos2 = TransformToParentPoint(WoodBody1, woodbodyPoint2)
    WoodBody1Pos3 = TransformToParentPoint(WoodBody1, woodbodyPoint3)
	-- firewood2 --
    WoodBody2Pos1 = TransformToParentPoint(WoodBody2, woodbodyPoint1)
    WoodBody2Pos2 = TransformToParentPoint(WoodBody2, woodbodyPoint2)
    WoodBody2Pos3 = TransformToParentPoint(WoodBody2, woodbodyPoint3)
	-- firewood3 --
    WoodBody3Pos1 = TransformToParentPoint(WoodBody3, woodbodyPoint1)
    WoodBody3Pos2 = TransformToParentPoint(WoodBody3, woodbodyPoint2)
    WoodBody3Pos3 = TransformToParentPoint(WoodBody3, woodbodyPoint3)
	-- firewood4 --
    WoodBody4Pos1 = TransformToParentPoint(WoodBody4, woodbodyPoint1)
    WoodBody4Pos2 = TransformToParentPoint(WoodBody4, woodbodyPoint2)
    WoodBody4Pos3 = TransformToParentPoint(WoodBody4, woodbodyPoint3)
	-- firewood5 --
    WoodBody5Pos1 = TransformToParentPoint(WoodBody5, woodbodyPoint1)
    WoodBody5Pos2 = TransformToParentPoint(WoodBody5, woodbodyPoint2)
    WoodBody5Pos3 = TransformToParentPoint(WoodBody5, woodbodyPoint3)
	
    -- spawnfire1 pos --
    WoodBody1FirePos1 = TransformToParentPoint(WoodBody1, woodbodyFirePoint1)
    WoodBody1FirePos2 = TransformToParentPoint(WoodBody1, woodbodyFirePoint2)
    WoodBody1FirePos3 = TransformToParentPoint(WoodBody1, woodbodyFirePoint3)
    WoodBody1FirePos4 = TransformToParentPoint(WoodBody1, woodbodyFirePoint4)
    WoodBody1FirePos5 = TransformToParentPoint(WoodBody1, woodbodyFirePoint5)
    WoodBody1FirePos6 = TransformToParentPoint(WoodBody1, woodbodyFirePoint6)
    WoodBody1FirePos7 = TransformToParentPoint(WoodBody1, woodbodyFirePoint7)
    WoodBody1FirePos8 = TransformToParentPoint(WoodBody1, woodbodyFirePoint8)
    WoodBody1FirePos9 = TransformToParentPoint(WoodBody1, woodbodyFirePoint9)
    WoodBody1FirePos10 = TransformToParentPoint(WoodBody1, woodbodyFirePoint10)
    WoodBody1FirePos11 = TransformToParentPoint(WoodBody1, woodbodyFirePoint11)
    WoodBody1FirePos12 = TransformToParentPoint(WoodBody1, woodbodyFirePoint12)
    WoodBody1FirePos13 = TransformToParentPoint(WoodBody1, woodbodyFirePoint13)
    WoodBody1FirePos14 = TransformToParentPoint(WoodBody1, woodbodyFirePoint14)
    -- spawnfire2 pos --
    WoodBody2FirePos1 = TransformToParentPoint(WoodBody2, woodbodyFirePoint1)
    WoodBody2FirePos2 = TransformToParentPoint(WoodBody2, woodbodyFirePoint2)
    WoodBody2FirePos3 = TransformToParentPoint(WoodBody2, woodbodyFirePoint3)
    WoodBody2FirePos4 = TransformToParentPoint(WoodBody2, woodbodyFirePoint4)
    WoodBody2FirePos5 = TransformToParentPoint(WoodBody2, woodbodyFirePoint5)
    WoodBody2FirePos6 = TransformToParentPoint(WoodBody2, woodbodyFirePoint6)
    WoodBody2FirePos7 = TransformToParentPoint(WoodBody2, woodbodyFirePoint7)
    WoodBody2FirePos8 = TransformToParentPoint(WoodBody2, woodbodyFirePoint8)
    WoodBody2FirePos9 = TransformToParentPoint(WoodBody2, woodbodyFirePoint9)
    WoodBody2FirePos10 = TransformToParentPoint(WoodBody2, woodbodyFirePoint10)
    WoodBody2FirePos11 = TransformToParentPoint(WoodBody2, woodbodyFirePoint11)
    WoodBody2FirePos12 = TransformToParentPoint(WoodBody2, woodbodyFirePoint12)
    WoodBody2FirePos13 = TransformToParentPoint(WoodBody2, woodbodyFirePoint13)
    WoodBody2FirePos14 = TransformToParentPoint(WoodBody2, woodbodyFirePoint14)
    -- spawnfire3 pos --
    WoodBody3FirePos1 = TransformToParentPoint(WoodBody3, woodbodyFirePoint1)
    WoodBody3FirePos2 = TransformToParentPoint(WoodBody3, woodbodyFirePoint2)
    WoodBody3FirePos3 = TransformToParentPoint(WoodBody3, woodbodyFirePoint3)
    WoodBody3FirePos4 = TransformToParentPoint(WoodBody3, woodbodyFirePoint4)
    WoodBody3FirePos5 = TransformToParentPoint(WoodBody3, woodbodyFirePoint5)
    WoodBody3FirePos6 = TransformToParentPoint(WoodBody3, woodbodyFirePoint6)
    WoodBody3FirePos7 = TransformToParentPoint(WoodBody3, woodbodyFirePoint7)
    WoodBody3FirePos8 = TransformToParentPoint(WoodBody3, woodbodyFirePoint8)
    WoodBody3FirePos9 = TransformToParentPoint(WoodBody3, woodbodyFirePoint9)
    WoodBody3FirePos10 = TransformToParentPoint(WoodBody3, woodbodyFirePoint10)
    WoodBody3FirePos11 = TransformToParentPoint(WoodBody3, woodbodyFirePoint11)
    WoodBody3FirePos12 = TransformToParentPoint(WoodBody3, woodbodyFirePoint12)
    WoodBody3FirePos13 = TransformToParentPoint(WoodBody3, woodbodyFirePoint13)
    WoodBody3FirePos14 = TransformToParentPoint(WoodBody3, woodbodyFirePoint14)
    -- spawnfire4 pos --
    WoodBody4FirePos1 = TransformToParentPoint(WoodBody4, woodbodyFirePoint1)
    WoodBody4FirePos2 = TransformToParentPoint(WoodBody4, woodbodyFirePoint2)
    WoodBody4FirePos3 = TransformToParentPoint(WoodBody4, woodbodyFirePoint3)
    WoodBody4FirePos4 = TransformToParentPoint(WoodBody4, woodbodyFirePoint4)
    WoodBody4FirePos5 = TransformToParentPoint(WoodBody4, woodbodyFirePoint5)
    WoodBody4FirePos6 = TransformToParentPoint(WoodBody4, woodbodyFirePoint6)
    WoodBody4FirePos7 = TransformToParentPoint(WoodBody4, woodbodyFirePoint7)
    WoodBody4FirePos8 = TransformToParentPoint(WoodBody4, woodbodyFirePoint8)
    WoodBody4FirePos9 = TransformToParentPoint(WoodBody4, woodbodyFirePoint9)
    WoodBody4FirePos10 = TransformToParentPoint(WoodBody4, woodbodyFirePoint10)
    WoodBody4FirePos11 = TransformToParentPoint(WoodBody4, woodbodyFirePoint11)
    WoodBody4FirePos12 = TransformToParentPoint(WoodBody4, woodbodyFirePoint12)
    WoodBody4FirePos13 = TransformToParentPoint(WoodBody4, woodbodyFirePoint13)
    WoodBody4FirePos14 = TransformToParentPoint(WoodBody4, woodbodyFirePoint14)

    -- spawnfire5 pos --
    WoodBody5FirePos1 = TransformToParentPoint(WoodBody5, woodbodyFirePoint1)
    WoodBody5FirePos2 = TransformToParentPoint(WoodBody5, woodbodyFirePoint2)
    WoodBody5FirePos3 = TransformToParentPoint(WoodBody5, woodbodyFirePoint3)
    WoodBody5FirePos4 = TransformToParentPoint(WoodBody5, woodbodyFirePoint4)
    WoodBody5FirePos5 = TransformToParentPoint(WoodBody5, woodbodyFirePoint5)
    WoodBody5FirePos6 = TransformToParentPoint(WoodBody5, woodbodyFirePoint6)
    WoodBody5FirePos7 = TransformToParentPoint(WoodBody5, woodbodyFirePoint7)
    WoodBody5FirePos8 = TransformToParentPoint(WoodBody5, woodbodyFirePoint8)
    WoodBody5FirePos9 = TransformToParentPoint(WoodBody5, woodbodyFirePoint9)
    WoodBody5FirePos10 = TransformToParentPoint(WoodBody5, woodbodyFirePoint10)
    WoodBody5FirePos11 = TransformToParentPoint(WoodBody5, woodbodyFirePoint11)
    WoodBody5FirePos12 = TransformToParentPoint(WoodBody5, woodbodyFirePoint12)
    WoodBody5FirePos13 = TransformToParentPoint(WoodBody5, woodbodyFirePoint13)
    WoodBody5FirePos14 = TransformToParentPoint(WoodBody5, woodbodyFirePoint14)
	
    firewoodIn = IsBodyInTrigger(ftrigger, fwood1) 
	          or IsBodyInTrigger(ftrigger, fwood2) 
			  or IsBodyInTrigger(ftrigger, fwood3) 
			  or IsBodyInTrigger(ftrigger, fwood4) 
			  or IsBodyInTrigger(ftrigger, fwood5)
	
    if GetPlayerInteractShape() == glass and InputPressed("interact") then
	    if not open then
            open = true
		else
		    open = false
		end
    end
	-- check if firewood is in fireplace --
	if IsBodyInTrigger(ftrigger, fwood1) then
	    woodIn1 = true
	elseif IsBodyInTrigger(ftrigger, fwood2) then
	    woodIn2 = true
	elseif IsBodyInTrigger(ftrigger, fwood3) then
	    woodIn3 = true
	elseif IsBodyInTrigger(ftrigger, fwood4) then
	    woodIn4 = true
	elseif IsBodyInTrigger(ftrigger, fwood5) then
	    woodIn5 = true
	end
	-- check if wood is in fireplace and fire button clicked then starts fire --
	if woodIn1 == true and fireOn1 == true then
	    woodtimer1 = woodtimer1 + dt
		if IsBodyInTrigger(ftrigger, fwood1) then
	        woodfireOn1 = true
		end
	end
	if woodIn2 == true and fireOn2 == true then
	    woodtimer2 = woodtimer2 + dt
		if IsBodyInTrigger(ftrigger, fwood2) then
	        woodfireOn2 = true
		end
	end
	if woodIn3 == true and fireOn3 == true then
	    woodtimer3 = woodtimer3 + dt
		if IsBodyInTrigger(ftrigger, fwood3) then
	        woodfireOn3 = true
		end
	end
	if woodIn4 == true and fireOn4 == true then
	    woodtimer4 = woodtimer4 + dt
		if IsBodyInTrigger(ftrigger, fwood4) then
	        woodfireOn4 = true
		end
	end
	if woodIn5 == true and fireOn5 == true then
	    woodtimer5 = woodtimer5 + dt
		if IsBodyInTrigger(ftrigger, fwood5) then
	        woodfireOn5 = true
		end
	end
	
	firecountmin = 0.1
	
	firecountwood1 = QueryAabbFireCount(WoodBody1FirePos10, WoodBody1FirePos11)
	firecountwood2 = QueryAabbFireCount(WoodBody2FirePos10, WoodBody2FirePos11)
	firecountwood3 = QueryAabbFireCount(WoodBody3FirePos10, WoodBody3FirePos11)
	firecountwood4 = QueryAabbFireCount(WoodBody4FirePos10, WoodBody4FirePos11)
	firecountwood5 = QueryAabbFireCount(WoodBody5FirePos10, WoodBody5FirePos11)
    
	if firecountwood1 > firecountmin then
	    woodfireOn1 = true
	end
	if firecountwood2 > firecountmin then
	    woodfireOn2 = true
	end
	if firecountwood3 > firecountmin then
	    woodfireOn3 = true
	end
	if firecountwood4 > firecountmin then
	    woodfireOn4 = true
	end
	if firecountwood5 > firecountmin then
	    woodfireOn5 = true
	end

	if GetString("game.player.tool") == "extinguisher" and InputDown("lmb") then
		extinguishertimer = extinguishertimer + dt
	    if IsBodyVisible(fwood1, 3) and extinguishertimer > 1 then
	        if woodfireOn1 == true then
	            woodfireOn1 = false
				fireOn1 = false
				woodIn1 = false
			end
		end
	    if IsBodyVisible(fwood2, 3) and extinguishertimer > 1 then
	        if woodfireOn2 == true then
	            woodfireOn2 = false
				fireOn2 = false
				woodIn2 = false
			end
		end
	    if IsBodyVisible(fwood3, 3) and extinguishertimer > 1 then
	        if woodfireOn3 == true then
	            woodfireOn3 = false
				fireOn3 = false
				woodIn3 = false
			end
		end
		if IsBodyVisible(fwood4, 3) and extinguishertimer > 1 then
			if woodfireOn4 == true then
	            woodfireOn4 = false
				fireOn4 = false
				woodIn4 = false
			end
		end
	    if IsBodyVisible(fwood5, 3) and extinguishertimer > 1 then
	        if woodfireOn5 == true then
	            woodfireOn5 = false
				fireOn5 = false
				woodIn5 = false
			end
		end
	end
	
	if GetString("game.player.tool") == "extinguisher" and InputReleased("lmb") then
		extinguishertimer = 0
	end
	
	local wet1, d1 = IsPointInWater(WoodBody1Pos1)
    if wet1 then
	    InWater1 = true
    else
	    InWater1 = false
	end
	if InWater1 == true then
	    woodfireOn1 = false
	    fireOn1 = false
	    woodIn1 = false
	end
	
	local wet2, d2 = IsPointInWater(WoodBody2Pos1)
    if wet2 then
	    InWater2 = true
    else
	    InWater2 = false
	end
	if InWater2 == true then
	    woodfireOn2 = false
	    fireOn2 = false
	    woodIn2 = false
	end
	
	local wet3, d3 = IsPointInWater(WoodBody3Pos1)
    if wet3 then
	    InWater3 = true
    else
	    InWater3 = false
	end
	if InWater3 == true then
	    woodfireOn3 = false
	    fireOn3 = false
	    woodIn3 = false
	end
	
	local wet4, d4 = IsPointInWater(WoodBody4Pos1)
    if wet4 then
	    InWater4 = true
    else
	    InWater4 = false
	end
	if InWater4 == true then
	    woodfireOn4 = false
	    fireOn4 = false
	    woodIn4 = false
	end
	
	local wet5, d5 = IsPointInWater(WoodBody5Pos1)
    if wet5 then
	    InWater5 = true
    else
	    InWater5 = false
	end
	if InWater5 == true then
	    woodfireOn5 = false
	    fireOn5 = false
	    woodIn5 = false
	end
	-- spawn particle if fire is started --
	if woodfireOn1 == true then
	    fireParticle1()
		smokeParticle1()
		SetTag(fwood1, "unbreakable")
		SpawnFire(WoodBody1FirePos1)
		SpawnFire(WoodBody1FirePos2)
		SpawnFire(WoodBody1FirePos3)
		SpawnFire(WoodBody1FirePos4)
		SpawnFire(WoodBody1FirePos5)
		SpawnFire(WoodBody1FirePos6)
		SpawnFire(WoodBody1FirePos7)
		SpawnFire(WoodBody1FirePos8)
		SpawnFire(WoodBody1FirePos9)
		SpawnFire(WoodBody1FirePos10)
		SpawnFire(WoodBody1FirePos11)
		SpawnFire(WoodBody1FirePos12)
		SpawnFire(WoodBody1FirePos13)
		SpawnFire(WoodBody1FirePos14)
		PlayLoop(fire,WoodBody1Pos1, 0.5)
		SetLightIntensity(w1light1, math.random()*(1.0-0.5) + 0.5)
		SetLightIntensity(w1light2, math.random()*(1.0-0.5) + 0.5)
		SetLightEnabled(w1light1, true)
		SetLightEnabled(w1light2, true)
	else
		SetLightEnabled(w1light1, false)
		SetLightEnabled(w1light2, false)
	end
	if woodfireOn2 == true then
	    fireParticle2()
		smokeParticle2()
		SetTag(fwood2, "unbreakable")
		SpawnFire(WoodBody2FirePos1)
		SpawnFire(WoodBody2FirePos2)
		SpawnFire(WoodBody2FirePos3)
		SpawnFire(WoodBody2FirePos4)
		SpawnFire(WoodBody2FirePos5)
		SpawnFire(WoodBody2FirePos6)
		SpawnFire(WoodBody2FirePos7)
		SpawnFire(WoodBody2FirePos8)
		SpawnFire(WoodBody2FirePos9)
		SpawnFire(WoodBody2FirePos10)
		SpawnFire(WoodBody2FirePos11)
		SpawnFire(WoodBody2FirePos12)
		SpawnFire(WoodBody2FirePos13)
		SpawnFire(WoodBody2FirePos14)
		PlayLoop(fire,WoodBody2Pos1, 0.5)
		SetLightIntensity(w2light1, math.random()*(1.0-0.5) + 0.5)
		SetLightIntensity(w2light2, math.random()*(1.0-0.5) + 0.5)
		SetLightEnabled(w2light1, true)
		SetLightEnabled(w2light2, true)
	else
		SetLightEnabled(w2light1, false)
		SetLightEnabled(w2light2, false)
	end
	if woodfireOn3 == true then
	    fireParticle3()
		smokeParticle3()
		SetTag(fwood3, "unbreakable")
		SpawnFire(WoodBody3FirePos1)
		SpawnFire(WoodBody3FirePos2)
		SpawnFire(WoodBody3FirePos3)
		SpawnFire(WoodBody3FirePos4)
		SpawnFire(WoodBody3FirePos5)
		SpawnFire(WoodBody3FirePos6)
		SpawnFire(WoodBody3FirePos7)
		SpawnFire(WoodBody3FirePos8)
		SpawnFire(WoodBody3FirePos9)
		SpawnFire(WoodBody3FirePos10)
		SpawnFire(WoodBody3FirePos11)
		SpawnFire(WoodBody3FirePos12)
		SpawnFire(WoodBody3FirePos13)
		SpawnFire(WoodBody3FirePos14)
		PlayLoop(fire,WoodBody3Pos1, 0.5)
		SetLightIntensity(w3light1, math.random()*(1.0-0.5) + 0.5)
		SetLightIntensity(w3light2, math.random()*(1.0-0.5) + 0.5)
		SetLightEnabled(w3light1, true)
		SetLightEnabled(w3light2, true)
	else
		SetLightEnabled(w3light1, false)
		SetLightEnabled(w3light2, false)
	end
	if woodfireOn4 == true then
	    fireParticle4()
		smokeParticle4()
		SetTag(fwood4, "unbreakable")
		SpawnFire(WoodBody4FirePos1)
		SpawnFire(WoodBody4FirePos2)
		SpawnFire(WoodBody4FirePos3)
		SpawnFire(WoodBody4FirePos4)
		SpawnFire(WoodBody4FirePos5)
		SpawnFire(WoodBody4FirePos6)
		SpawnFire(WoodBody4FirePos7)
		SpawnFire(WoodBody4FirePos8)
		SpawnFire(WoodBody4FirePos9)
		SpawnFire(WoodBody4FirePos10)
		SpawnFire(WoodBody4FirePos11)
		SpawnFire(WoodBody4FirePos12)
		SpawnFire(WoodBody4FirePos13)
		SpawnFire(WoodBody4FirePos14)
		PlayLoop(fire,WoodBody4Pos1, 0.5)
		SetLightIntensity(w4light1, math.random()*(1.0-0.5) + 0.5)
		SetLightIntensity(w4light2, math.random()*(1.0-0.5) + 0.5)
		SetLightEnabled(w4light1, true)
		SetLightEnabled(w4light2, true)
	else
		SetLightEnabled(w4light1, false)
		SetLightEnabled(w4light2, false)
	end
	if woodfireOn5 == true then
	    fireParticle5()
		smokeParticle5()
		SetTag(fwood5, "unbreakable")
		SpawnFire(WoodBody5FirePos1)
		SpawnFire(WoodBody5FirePos2)
		SpawnFire(WoodBody5FirePos3)
		SpawnFire(WoodBody5FirePos4)
		SpawnFire(WoodBody5FirePos5)
		SpawnFire(WoodBody5FirePos6)
		SpawnFire(WoodBody5FirePos7)
		SpawnFire(WoodBody5FirePos8)
		SpawnFire(WoodBody5FirePos9)
		SpawnFire(WoodBody5FirePos10)
		SpawnFire(WoodBody5FirePos11)
		SpawnFire(WoodBody5FirePos12)
		SpawnFire(WoodBody5FirePos13)
		SpawnFire(WoodBody5FirePos14)
		PlayLoop(fire,WoodBody5Pos1, 0.5)
		SetLightIntensity(w5light1, math.random()*(1.0-0.5) + 0.5)
		SetLightIntensity(w5light2, math.random()*(1.0-0.5) + 0.5)
		SetLightEnabled(w5light1, true)
		SetLightEnabled(w5light2, true)
	else
		SetLightEnabled(w5light1, false)
		SetLightEnabled(w5light2, false)
	end
	-- when timer is over 600 delete wood and reset all stats --
	if woodtimer1 > 600 then
	    if woodfireOn1 == true then
	        Delete(fwood1)
			woodfireOn1 = false
			woodIn1 = false
			woodtimer1 = 0
		end
	end
	if woodtimer2 > 600 then
		if woodfireOn2 == true then
		    Delete(fwood2)
			woodfireOn2 = false
			woodIn2 = false
			woodtimer2 = 0
		end
	end
	if woodtimer3 > 600 then
		if woodfireOn3 == true then
		    Delete(fwood3)
			woodfireOn3 = false
			woodIn3 = false
			woodtimer3 = 0
		end
	end
	if woodtimer4 > 600 then
		if woodfireOn4 == true then
		    Delete(fwood4)
			woodfireOn4 = false
			woodIn4 = false
			woodtimer4 = 0
		end
	end
	if woodtimer5 > 600 then
		if woodfireOn5 == true then
		    Delete(fwood5)
			woodfireOn5 = false
			woodIn5 = false
			woodtimer5 = 0
	    end
	end
	
    if GetPlayerInteractShape() == firestart and InputPressed("interact") then
	    if IsBodyInTrigger(ftrigger, fwood1) then
	        if fireOn1 == false then
		        fireOn1 = true
			end
		end
		if IsBodyInTrigger(ftrigger, fwood2) then
	        if fireOn2 == false then
		        fireOn2 = true
			end
		end
		if IsBodyInTrigger(ftrigger, fwood3) then
	        if fireOn3 == false then
		        fireOn3 = true
			end
		end
		if IsBodyInTrigger(ftrigger, fwood4) then
	        if fireOn4 == false then
		        fireOn4 = true
			end
		end
		if IsBodyInTrigger(ftrigger, fwood5) then
	        if fireOn5 == false then
		        fireOn5 = true
			end
		end
    end

    if open then
        for i=1,#motors do
            local motor = motors[i]
            SetJointMotorTarget(motor, 0.6, 0.5, 100)
        end
    end
    if not open then
        for i=1,#motors do
            local motor = motors[i]
            SetJointMotorTarget(motor, 0.0, 0.5, 100)
        end
    end

end

function smokeParticle1()
    -- 1. Position --
	ParticleType("smoke")
	ParticleTile(1)
	ParticleColor(0.3,0.3,0.3)
	ParticleRadius(0.07)
	ParticleAlpha(0.8)
	ParticleGravity(2)
	ParticleDrag(1)
	ParticleEmissive(0.66)
	ParticleRotation(0.25)
	ParticleStretch(0)
	ParticleSticky(0)
	ParticleCollide(1, 1, "constant", 0.05)
	SpawnParticle(WoodBody1Pos1, Vec(0, 0.1, 0), 15)
    -- 2. Position --
	ParticleType("smoke")
	ParticleTile(1)
	ParticleColor(0.3,0.3,0.3)
	ParticleRadius(0.07)
	ParticleAlpha(0.8)
	ParticleGravity(2)
	ParticleDrag(1)
	ParticleEmissive(0.66)
	ParticleRotation(0.25)
	ParticleStretch(0)
	ParticleSticky(0)
	ParticleCollide(1, 1, "constant", 0.05)
	SpawnParticle(WoodBody1Pos2, Vec(0, 0.1, 0), 15)
    -- 3. Position --
	ParticleType("smoke")
	ParticleTile(1)
	ParticleColor(0.3,0.3,0.3)
	ParticleRadius(0.07)
	ParticleAlpha(0.8)
	ParticleGravity(2)
	ParticleDrag(1)
	ParticleEmissive(0.66)
	ParticleRotation(0.25)
	ParticleStretch(0)
	ParticleSticky(0)
	ParticleCollide(1, 1, "constant", 0.05)
	SpawnParticle(WoodBody1Pos3, Vec(0, 0.1, 0), 15)
end

function smokeParticle2()
    -- 1. Position --
	ParticleType("smoke")
	ParticleTile(1)
	ParticleColor(0.3,0.3,0.3)
	ParticleRadius(0.07)
	ParticleAlpha(0.8)
	ParticleGravity(2)
	ParticleDrag(1)
	ParticleEmissive(0.66)
	ParticleRotation(0.25)
	ParticleStretch(0)
	ParticleSticky(0)
	ParticleCollide(1, 1, "constant", 0.05)
	SpawnParticle(WoodBody2Pos1, Vec(0, 0.1, 0), 15)
    -- 2. Position --
	ParticleType("smoke")
	ParticleTile(1)
	ParticleColor(0.3,0.3,0.3)
	ParticleRadius(0.07)
	ParticleAlpha(0.8)
	ParticleGravity(2)
	ParticleDrag(1)
	ParticleEmissive(0.66)
	ParticleRotation(0.25)
	ParticleStretch(0)
	ParticleSticky(0)
	ParticleCollide(1, 1, "constant", 0.05)
	SpawnParticle(WoodBody2Pos2, Vec(0, 0.1, 0), 15)
    -- 3. Position --
	ParticleType("smoke")
	ParticleTile(1)
	ParticleColor(0.3,0.3,0.3)
	ParticleRadius(0.07)
	ParticleAlpha(0.8)
	ParticleGravity(2)
	ParticleDrag(1)
	ParticleEmissive(0.66)
	ParticleRotation(0.25)
	ParticleStretch(0)
	ParticleSticky(0)
	ParticleCollide(1, 1, "constant", 0.05)
	SpawnParticle(WoodBody2Pos3, Vec(0, 0.1, 0), 15)
end

function smokeParticle3()
    -- 1. Position --
	ParticleType("smoke")
	ParticleTile(1)
	ParticleColor(0.3,0.3,0.3)
	ParticleRadius(0.07)
	ParticleAlpha(0.8)
	ParticleGravity(2)
	ParticleDrag(1)
	ParticleEmissive(0.66)
	ParticleRotation(0.25)
	ParticleStretch(0)
	ParticleSticky(0)
	ParticleCollide(1, 1, "constant", 0.05)
	SpawnParticle(WoodBody3Pos1, Vec(0, 0.1, 0), 15)
    -- 2. Position --
	ParticleType("smoke")
	ParticleTile(1)
	ParticleColor(0.3,0.3,0.3)
	ParticleRadius(0.07)
	ParticleAlpha(0.8)
	ParticleGravity(2)
	ParticleDrag(1)
	ParticleEmissive(0.66)
	ParticleRotation(0.25)
	ParticleStretch(0)
	ParticleSticky(0)
	ParticleCollide(1, 1, "constant", 0.05)
	SpawnParticle(WoodBody3Pos2, Vec(0, 0.1, 0), 15)
    -- 3. Position --
	ParticleType("smoke")
	ParticleTile(1)
	ParticleColor(0.3,0.3,0.3)
	ParticleRadius(0.07)
	ParticleAlpha(0.8)
	ParticleGravity(2)
	ParticleDrag(1)
	ParticleEmissive(0.66)
	ParticleRotation(0.25)
	ParticleStretch(0)
	ParticleSticky(0)
	ParticleCollide(1, 1, "constant", 0.05)
	SpawnParticle(WoodBody3Pos3, Vec(0, 0.1, 0), 15)
end

function smokeParticle4()
    -- 1. Position --
	ParticleType("smoke")
	ParticleTile(1)
	ParticleColor(0.3,0.3,0.3)
	ParticleRadius(0.07)
	ParticleAlpha(0.8)
	ParticleGravity(2)
	ParticleDrag(1)
	ParticleEmissive(0.66)
	ParticleRotation(0.25)
	ParticleStretch(0)
	ParticleSticky(0)
	ParticleCollide(1, 1, "constant", 0.05)
	SpawnParticle(WoodBody4Pos1, Vec(0, 0.1, 0), 15)
    -- 2. Position --
	ParticleType("smoke")
	ParticleTile(1)
	ParticleColor(0.3,0.3,0.3)
	ParticleRadius(0.07)
	ParticleAlpha(0.8)
	ParticleGravity(2)
	ParticleDrag(1)
	ParticleEmissive(0.66)
	ParticleRotation(0.25)
	ParticleStretch(0)
	ParticleSticky(0)
	ParticleCollide(1, 1, "constant", 0.05)
	SpawnParticle(WoodBody4Pos2, Vec(0, 0.1, 0), 15)
    -- 3. Position --
	ParticleType("smoke")
	ParticleTile(1)
	ParticleColor(0.3,0.3,0.3)
	ParticleRadius(0.07)
	ParticleAlpha(0.8)
	ParticleGravity(2)
	ParticleDrag(1)
	ParticleEmissive(0.66)
	ParticleRotation(0.25)
	ParticleStretch(0)
	ParticleSticky(0)
	ParticleCollide(1, 1, "constant", 0.05)
	SpawnParticle(WoodBody4Pos3, Vec(0, 0.1, 0), 15)
end

function smokeParticle5()
    -- 1. Position --
	ParticleType("smoke")
	ParticleTile(1)
	ParticleColor(0.3,0.3,0.3)
	ParticleRadius(0.07)
	ParticleAlpha(0.8)
	ParticleGravity(2)
	ParticleDrag(1)
	ParticleEmissive(0.66)
	ParticleRotation(0.25)
	ParticleStretch(0)
	ParticleSticky(0)
	ParticleCollide(1, 1, "constant", 0.05)
	SpawnParticle(WoodBody5Pos1, Vec(0, 0.1, 0), 15)
    -- 2. Position --
	ParticleType("smoke")
	ParticleTile(1)
	ParticleColor(0.3,0.3,0.3)
	ParticleRadius(0.07)
	ParticleAlpha(0.8)
	ParticleGravity(2)
	ParticleDrag(1)
	ParticleEmissive(0.66)
	ParticleRotation(0.25)
	ParticleStretch(0)
	ParticleSticky(0)
	ParticleCollide(1, 1, "constant", 0.05)
	SpawnParticle(WoodBody5Pos2, Vec(0, 0.1, 0), 15)
    -- 3. Position --
	ParticleType("smoke")
	ParticleTile(1)
	ParticleColor(0.3,0.3,0.3)
	ParticleRadius(0.07)
	ParticleAlpha(0.8)
	ParticleGravity(2)
	ParticleDrag(1)
	ParticleEmissive(0.66)
	ParticleRotation(0.25)
	ParticleStretch(0)
	ParticleSticky(0)
	ParticleCollide(1, 1, "constant", 0.05)
	SpawnParticle(WoodBody5Pos3, Vec(0, 0.1, 0), 15)
end

function fireParticle1()
    --1. Position --
	ParticleReset()			
	ParticleColor(1,math.random(40, 50)*.01,0, 1,math.random(20, 40)*.01,0) 
	ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody1Pos1, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,math.random(75, 85)*.01,.1, 1,math.random(55, 65)*.01,.4)   
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody1Pos1, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,1,.8, .8,.8,math.random(50, 60)*.01) 
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(.5, 0, "easeout")
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody1Pos1, Vec(0, 0.01, 0), 0.4)
	
    --2. Position --
	ParticleReset()			
	ParticleColor(1,math.random(40, 50)*.01,0, 1,math.random(20, 40)*.01,0) 
	ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody1Pos2, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,math.random(75, 85)*.01,.1, 1,math.random(55, 65)*.01,.4)   
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody1Pos2, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,1,.8, .8,.8,math.random(50, 60)*.01) 
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(.5, 0, "easeout")
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody1Pos2, Vec(0, 0.01, 0), 0.4)
	
    --3. Position --
	ParticleReset()			
	ParticleColor(1,math.random(40, 50)*.01,0, 1,math.random(20, 40)*.01,0) 
	ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody1Pos3, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,math.random(75, 85)*.01,.1, 1,math.random(55, 65)*.01,.4)   
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody1Pos3, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,1,.8, .8,.8,math.random(50, 60)*.01) 
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(.5, 0, "easeout")
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody1Pos3, Vec(0, 0.01, 0), 0.4)
end

function fireParticle2()
    --1. Position --
	ParticleReset()			
	ParticleColor(1,math.random(40, 50)*.01,0, 1,math.random(20, 40)*.01,0) 
	ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody2Pos1, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,math.random(75, 85)*.01,.1, 1,math.random(55, 65)*.01,.4)   
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody2Pos1, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,1,.8, .8,.8,math.random(50, 60)*.01) 
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(.5, 0, "easeout")
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody2Pos1, Vec(0, 0.01, 0), 0.4)
	
    --2. Position --
	ParticleReset()			
	ParticleColor(1,math.random(40, 50)*.01,0, 1,math.random(20, 40)*.01,0) 
	ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody2Pos2, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,math.random(75, 85)*.01,.1, 1,math.random(55, 65)*.01,.4)   
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody2Pos2, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,1,.8, .8,.8,math.random(50, 60)*.01) 
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(.5, 0, "easeout")
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody2Pos2, Vec(0, 0.01, 0), 0.4)
	
    --3. Position --
	ParticleReset()			
	ParticleColor(1,math.random(40, 50)*.01,0, 1,math.random(20, 40)*.01,0) 
	ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody2Pos3, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,math.random(75, 85)*.01,.1, 1,math.random(55, 65)*.01,.4)   
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody2Pos3, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,1,.8, .8,.8,math.random(50, 60)*.01) 
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(.5, 0, "easeout")
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody2Pos3, Vec(0, 0.01, 0), 0.4)
end

function fireParticle3()
    --1. Position --
	ParticleReset()			
	ParticleColor(1,math.random(40, 50)*.01,0, 1,math.random(20, 40)*.01,0) 
	ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody3Pos1, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,math.random(75, 85)*.01,.1, 1,math.random(55, 65)*.01,.4)   
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody3Pos1, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,1,.8, .8,.8,math.random(50, 60)*.01) 
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(.5, 0, "easeout")
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody3Pos1, Vec(0, 0.01, 0), 0.4)
	
    --2. Position --
	ParticleReset()			
	ParticleColor(1,math.random(40, 50)*.01,0, 1,math.random(20, 40)*.01,0) 
	ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody3Pos2, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,math.random(75, 85)*.01,.1, 1,math.random(55, 65)*.01,.4)   
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody3Pos2, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,1,.8, .8,.8,math.random(50, 60)*.01) 
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(.5, 0, "easeout")
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody3Pos2, Vec(0, 0.01, 0), 0.4)
	
    --3. Position --
	ParticleReset()			
	ParticleColor(1,math.random(40, 50)*.01,0, 1,math.random(20, 40)*.01,0) 
	ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody3Pos3, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,math.random(75, 85)*.01,.1, 1,math.random(55, 65)*.01,.4)   
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody3Pos3, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,1,.8, .8,.8,math.random(50, 60)*.01) 
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(.5, 0, "easeout")
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody3Pos3, Vec(0, 0.01, 0), 0.4)
end

function fireParticle4()
    --1. Position --
	ParticleReset()			
	ParticleColor(1,math.random(40, 50)*.01,0, 1,math.random(20, 40)*.01,0) 
	ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody4Pos1, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,math.random(75, 85)*.01,.1, 1,math.random(55, 65)*.01,.4)   
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody4Pos1, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,1,.8, .8,.8,math.random(50, 60)*.01) 
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(.5, 0, "easeout")
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody4Pos1, Vec(0, 0.01, 0), 0.4)
	
    --2. Position --
	ParticleReset()			
	ParticleColor(1,math.random(40, 50)*.01,0, 1,math.random(20, 40)*.01,0) 
	ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody4Pos2, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,math.random(75, 85)*.01,.1, 1,math.random(55, 65)*.01,.4)   
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody4Pos2, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,1,.8, .8,.8,math.random(50, 60)*.01) 
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(.5, 0, "easeout")
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody4Pos2, Vec(0, 0.01, 0), 0.4)
	
    --3. Position --
	ParticleReset()			
	ParticleColor(1,math.random(40, 50)*.01,0, 1,math.random(20, 40)*.01,0) 
	ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody4Pos3, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,math.random(75, 85)*.01,.1, 1,math.random(55, 65)*.01,.4)   
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody4Pos3, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,1,.8, .8,.8,math.random(50, 60)*.01) 
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(.5, 0, "easeout")
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody4Pos3, Vec(0, 0.01, 0), 0.4)
end

function fireParticle5()
    --1. Position --
	ParticleReset()			
	ParticleColor(1,math.random(40, 50)*.01,0, 1,math.random(20, 40)*.01,0) 
	ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody5Pos1, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,math.random(75, 85)*.01,.1, 1,math.random(55, 65)*.01,.4)   
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody5Pos1, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,1,.8, .8,.8,math.random(50, 60)*.01) 
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(.5, 0, "easeout")
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody5Pos1, Vec(0, 0.01, 0), 0.4)
	
    --2. Position --
	ParticleReset()			
	ParticleColor(1,math.random(40, 50)*.01,0, 1,math.random(20, 40)*.01,0) 
	ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody5Pos2, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,math.random(75, 85)*.01,.1, 1,math.random(55, 65)*.01,.4)   
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody5Pos2, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,1,.8, .8,.8,math.random(50, 60)*.01) 
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(.5, 0, "easeout")
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody5Pos2, Vec(0, 0.01, 0), 0.4)
	
    --3. Position --
	ParticleReset()			
	ParticleColor(1,math.random(40, 50)*.01,0, 1,math.random(20, 40)*.01,0) 
	ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody5Pos3, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,math.random(75, 85)*.01,.1, 1,math.random(55, 65)*.01,.4)   
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(1, 0)
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody5Pos3, Vec(0, 0.01, 0), 0.4)
	ParticleColor(1,1,.8, .8,.8,math.random(50, 60)*.01) 
    ParticleEmissive(0.33)
	ParticleCollide(0.0)
	ParticleTile(5)
	ParticleRadius(math.random(0.5, 2)*0.1)
	ParticleAlpha(.5, 0, "easeout")
	ParticleGravity(5)
	ParticleDrag(0)
	SpawnParticle(WoodBody5Pos3, Vec(0, 0.01, 0), 0.4)
end
