function init()
    waterhot = FindShape("hotwater")
    guestsink = FindShape("guestsink", true)
    waterhothandle = FindJoint("hotwaterhandle")
    light = FindLight("waterlightguest2", true)
	
    OnSwitch = GetFloatParam("OnSwitch", 2)
    OffSwitch = GetFloatParam("OffSwitch", 0)

    OnSpeed = GetFloatParam("OnSpeed", 2)
    OffSpeed =  GetFloatParam("OffSpeed", 2)
    waterOn = false
end

function tick(dt)
	broken = IsShapeBroken(guestsink)

    if not broken then

        if GetPlayerInteractShape() == waterhot and InputPressed("interact") then
		    if not waterOn then

			    waterOn = true
		    else

			    waterOn = false
		    end
	    end
		
		    if waterOn then
		        SetTag(waterhot, "interact")
			    SetLightEnabled(light, true)
                SetJointMotorTarget(waterhothandle, OnSwitch, OnSpeed)
	            ParticleReset()
                ParticleType(smoke)
	            ParticleTile(1)
		        ParticleRadius(0.03, 0.01)
	            ParticleColor(0.9, 0.9, 1.0)
                ParticleGravity(-0.1)
			    ParticleCollide(0, 0.5)
	            for i=1,1 do
		            SpawnParticle(Vec(9.25, 1.94, -6.65), Vec(0.0, -1.2, 0.0), 3)
		        end
		    else
			    SetTag(waterhot, "interact")
		    	SetLightEnabled(light, false)
                SetJointMotorTarget(waterhothandle, OffSwitch, OffSpeed)

	        end
	else
	    SetLightEnabled(light, false)	
	end	    
	
    
end

