function init()
    waterhot = FindShape("hotwater")
    mainsink = FindShape("mainsink1", true)
    waterhothandle = FindJoint("hotwaterhandle")
    light = FindLight("waterlightmain2", true)
	
    OnSwitch = GetFloatParam("OnSwitch", 2)
    OffSwitch = GetFloatParam("OffSwitch", 0)

    OnSpeed = GetFloatParam("OnSpeed", 2)
    OffSpeed =  GetFloatParam("OffSpeed", 2)
    waterOn = false
end

function tick(dt)
	broken = IsShapeBroken(mainsink)

    if not broken then

        if GetPlayerInteractShape() == waterhot and InputPressed("interact") then
		    if not waterOn then
 
			    waterOn = true
	     	else

		    waterOn = false
	    	end
	    end
		
    		if waterOn then
    		    SetTag(waterhot, "interact")
    			SetLightEnabled(light, true)
                SetJointMotorTarget(waterhothandle, OnSwitch, OnSpeed)
     	        ParticleReset()
                ParticleType(smoke)
	            ParticleTile(1)
		        ParticleRadius(0.03, 0.01)
	            ParticleColor(0.9, 0.9, 1.0)
                ParticleGravity(-0.1)
			    ParticleCollide(0, 0.5)
	            for i=1,1 do
		            SpawnParticle(Vec(-7.05, 1.84, -6.25), Vec(0.0, -1.2, 0.0), 3)
		        end
		    else
			    SetTag(waterhot, "interact")
			    SetLightEnabled(light, false)
                SetJointMotorTarget(waterhothandle, OffSwitch, OffSpeed)

	        end
	else
	    SetLightEnabled(light, false)	
	end	 
    
end

