function init()
    l = FindShape("lock")
	
    m = FindJoints("motor")
	
	d = FindShape("door")
	
	f = FindShape("framelock")
	
	t = FindTrigger("trigger")
	
    locked = false

end

function tick(dt)
	framebroken = IsShapeBroken(f)
	
	doorbroken = IsShapeBroken(l)
    
	
	if locked then
        SetTag(l, "interact", "locked")
	else
		SetTag(l, "interact", "unlocked")
	end
	
	
	if IsShapeInTrigger(t, d) then
	    if GetPlayerInteractShape() == l and InputPressed("interact") then
	        if not locked then
		        locked = true
	        else
		        locked = false
			end
	    end
	end
	
	if not doorbroken and not framebroken then
	    if locked then
            for i=1,#m do
                local motor1 = m[i]
                SetJointMotorTarget(motor1, 0, 10)
            end
	    else
		    if IsShapeInTrigger(t, d) then
			    local body1 = GetPlayerGrabShape("d")
			    if body1 ~= 1 then
			        for i=1,#m do
                        local motor1 = m[i]
                        SetJointMotorTarget(motor1, 0, 10, 10000)
					end
                end
			    if body1 ~= 0 then
                    for i=1,#m do
                        local motor1 = m[i]
                        SetJointMotorTarget(motor1, 0, 0, 50)
					end
			    end
			end
        end
	end
	
	
	if doorbroken or framebroken then
	    if locked then
            for i=1,#m do
                local motor1 = m[i]
                SetJointMotorTarget(motor1, 0, 0, 50)
            end
	    else
            for i=1,#m do
                local motor1 = m[i]
                SetJointMotorTarget(motor1, 0, 0, 50)
			end
        end
	end
	
end