function init()
    open = FindShapes("button")
    motors1 = FindJoints("motor1")
    motors2 = FindJoints("motor2")
    trigger1 = FindTrigger("gate1")
	door = FindShape("gatedoor", true)

	
    OpenTarget = GetFloatParam("OpenTarget", 62)
    ClosedTarget = GetFloatParam("ClosedTarget", 0)

    CloseSpeed = GetFloatParam("CloseSpeed", 0.5)
    OpenSpeed =  GetFloatParam("OpenSpeed", 0.5)
	
	number0 = FindShape("0s", true)
	number1 = FindShape("1s", true)
	number2 = FindShape("2s", true)
	number3 = FindShape("3s", true)
	number4 = FindShape("4s", true)
	number5 = FindShape("5s", true)
	number6 = FindShape("6s", true)
	number7 = FindShape("7s", true)
	number8 = FindShape("8s", true)
	number9 = FindShape("9s", true)
	
	gateunlockcode1 = false
	gateunlockcode2 = false
	gateunlockcode3 = false
	gateunlockcode4 = false
	gateunlockcode5 = false
	gatelockcode1 = false
	gatelockcode2 = false
	gatelockcode3 = false
	gatelockcode4 = false
	gatelockcode5 = false
    gatelocked = true
	gatemotors = FindJoints("gatelockmotor")
	key3 = FindShape("lock3")
    SetTag(key3, "interact")
	key4 = FindShape("lock4")
    SetTag(key4, "interact")
end

function tick(dt)
    PlayerPos = GetPlayerPos()
	
	broken = IsShapeBroken(open)
	
    for i=1, #open do
	    local button = open[i]
	    SetTag(button, "interact")
	end
	
	if not gatelocked then
        for i=1,#motors1 do
            local motor1 = motors1[i]
            SetJointMotorTarget(motor1, -90, OpenSpeed, 100)
        end
        for i=1,#motors2 do
            local motor2 = motors2[i]
            SetJointMotorTarget(motor2, -130, OpenSpeed, 100)
        end
	else
        for i=1,#motors1 do
            local motor1 = motors1[i]
            SetJointMotorTarget(motor1, ClosedTarget, CloseSpeed, 100)
        end
        for i=1,#motors2 do
            local motor2 = motors2[i]
            SetJointMotorTarget(motor2, ClosedTarget, CloseSpeed, 100)
        end
	end
	
    if GetPlayerInteractShape() == key3 and InputPressed("interact") then
        if not gatelocked then
	        gatelocked = true
	        gateunlockcode1 = false
	        gateunlockcode2 = false
	        gateunlockcode3 = false
	        gateunlockcode4 = false
	        gateunlockcode5 = false
	    else
	        gatelocked = false
		    gatelockcode1 = false
	        gatelockcode2 = false
	        gatelockcode3 = false
	        gatelockcode4 = false
	        gatelockcode5 = false
	    end
    end
	
    if GetPlayerInteractShape() == key4 and InputPressed("interact") then
        if not gatelocked then
	        gatelocked = true
	        gateunlockcode1 = false
	        gateunlockcode2 = false
	        gateunlockcode3 = false
	        gateunlockcode4 = false
	        gateunlockcode5 = false
	    else
	        gatelocked = false
		    gatelockcode1 = false
	        gatelockcode2 = false
	        gatelockcode3 = false
	        gatelockcode4 = false
	        gatelockcode5 = false
	    end
    end
	
	-- wrong lock number1 lock code 52930 unlock code 76481
    if GetPlayerInteractShape() == number7 and InputPressed("interact") then
	    if gatelockcode1 then
	        gatelockcode1 = false
			gatelockcode2 = false
	        gatelockcode3 = false
			gatelockcode4 = false
			gatelockcode5 = false
	    else
	        gatelockcode1 = false
			gatelockcode2 = false
	        gatelockcode3 = false
			gatelockcode4 = false
			gatelockcode5 = false
	    end
	end
	-- wrong lock number2 lock code 52930 unlock code 76481
    if GetPlayerInteractShape() == number6 and InputPressed("interact") then
	    if gatelockcode1 then
	        gatelockcode1 = false
			gatelockcode2 = false
	        gatelockcode3 = false
			gatelockcode4 = false
			gatelockcode5 = false
	    else
	        gatelockcode1 = false
			gatelockcode2 = false
	        gatelockcode3 = false
			gatelockcode4 = false
			gatelockcode5 = false
	    end
	end
	-- wrong lock number3 lock code 52930 unlock code 76481
    if GetPlayerInteractShape() == numbe4 and InputPressed("interact") then
	    if gatelockcode1 then
	        gatelockcode1 = false
			gatelockcode2 = false
	        gatelockcode3 = false
			gatelockcode4 = false
			gatelockcode5 = false
	    else
	        gatelockcode1 = false
			gatelockcode2 = false
	        gatelockcode3 = false
			gatelockcode4 = false
			gatelockcode5 = false
	    end
	end
	-- wrong lock number4 lock code 52930 unlock code 76481
    if GetPlayerInteractShape() == number8 and InputPressed("interact") then
	    if gatelockcode1 then
	        gatelockcode1 = false
			gatelockcode2 = false
	        gatelockcode3 = false
			gatelockcode4 = false
			gatelockcode5 = false
	    else
	        gatelockcode1 = false
			gatelockcode2 = false
	        gatelockcode3 = false
			gatelockcode4 = false
			gatelockcode5 = false
	    end
	end
	-- wrong lock number5 lock code 52930 unlock code 76481
    if GetPlayerInteractShape() == number1 and InputPressed("interact") then
	    if gatelockcode1 then
	        gatelockcode1 = false
			gatelockcode2 = false
	        gatelockcode3 = false
			gatelockcode4 = false
			gatelockcode5 = false
	    else
	        gatelockcode1 = false
			gatelockcode2 = false
	        gatelockcode3 = false
			gatelockcode4 = false
			gatelockcode5 = false
	    end
	end
	-- wrong unlock number1 lock code 52930 unlock code 76481
    if GetPlayerInteractShape() == number5 and InputPressed("interact") then
	    if gatecode1 then
	        gateunlockcode1 = false
			gateunlockcode2 = false
	        gateunlockcode3 = false
			gateunlockcode4 = false
			gateunlockcode5 = false
	    else
	        gateunlockcode1 = false
			gateunlockcode2 = false
	        gateunlockcode3 = false
			gateunlockcode4 = false
			gateunlockcode5 = false
	    end
	end
	-- wrong unlock number2 lock code 52930 unlock code 76481
    if GetPlayerInteractShape() == number2 and InputPressed("interact") then
	    if gateunlockcode1 then
	        gateunlockcode1 = false
			gateunlockcode2 = false
	        gateunlockcode3 = false
			gateunlockcode4 = false
			gateunlockcode5 = false
	    else
	        gateunlockcode1 = false
			gateunlockcode2 = false
	        gateunlockcode3 = false
			gateunlockcode4 = false
			gateunlockcode5 = false
	    end
	end 
	-- wrong unlock number3 lock code 52930 unlock code 76481
    if GetPlayerInteractShape() == number9 and InputPressed("interact") then
	    if gateunlockcode1 then
	        gateunlockcode1 = false
			gateunlockcode2 = false
	        gateunlockcode3 = false
			gateunlockcode4 = false
			gateunlockcode5 = false
	    else
	        gateunlockcode1 = false
			gateunlockcode2 = false
	        gateunlockcode3 = false
			gateunlockcode4 = false
			gateunlockcode5 = false
	    end
	end
	-- wrong unlock number4 lock code 52930 unlock code 76481
    if GetPlayerInteractShape() == number3 and InputPressed("interact") then
	    if gateunlockcode1 then
	        gateunlockcode1 = false
			gateunlockcode2 = false
	        gateunlockcode3 = false
			gateunlockcode4 = false
			gateunlockcode5 = false
	    else
	        gateunlockcode1 = false
			gateunlockcode2 = false
	        gateunlockcode3 = false
			gateunlockcode4 = false
			gateunlockcode5 = false
	    end
	end	 
	-- wrong unlock number5 lock code 52930 unlock code 76481
    if GetPlayerInteractShape() == number0 and InputPressed("interact") then
	    if gateunlockcode1 then
	        gateunlockcode1 = false
			gateunlockcode2 = false
	        gateunlockcode3 = false
			gateunlockcode4 = false
			gateunlockcode5 = false
	    else
	        gateunlockcode1 = false
			gateunlockcode2 = false
	        gateunlockcode3 = false
			gateunlockcode4 = false
			gateunlockcode5 = false
	    end
	end	
	-- unlock code1 lock code 52930 unlock code 76481
	if GetPlayerInteractShape() == number7 and InputPressed("interact") then
	    if not gateunlockcode1 then
	        gateunlockcode1 = true
	    else
	        gateunlockcode1 = true
	    end
	end
	-- unlock code2 lock code 52930 unlock code 76481
	if GetPlayerInteractShape() == number6 and InputPressed("interact") then
	    if gateunlockcode1 and not gateunlockcode2 then
	        gateunlockcode2 = true
	    else
	        gateunlockcode2 = false
	    end
	end
	-- unlock code3 lock code 52930 unlock code 76481
	if GetPlayerInteractShape() == number4 and InputPressed("interact") then
	    if gateunlockcode1 and gateunlockcode2 and not gateunlockcode3 then
	        gateunlockcode3 = true
	    else
	        gateunlockcode3 = false
	    end
	end
	-- unlock code4 lock code 52930 unlock code 76481
	if GetPlayerInteractShape() == number8 and InputPressed("interact") then
	    if gateunlockcode1 and gateunlockcode2 and gateunlockcode3 and not gateunlockcode4 then
	        gateunlockcode4 = true
	    else
	        gateunlockcode4 = false
	    end
	end
	-- unlock code5 lock code 52930 unlock code 76481
	if GetPlayerInteractShape() == number1 and InputPressed("interact") then
	    if gateunlockcode1 and gateunlockcode2 and gateunlockcode3 and gateunlockcode4 and not gateunlockcode5 then
	        gateunlockcode5 = true
	    else
	        gateunlockcode5 = false
	    end
	end
	-- lock code1 lock code 52930 unlock code 76481
	if GetPlayerInteractShape() == number5 and InputPressed("interact") then
	    if not gatelockcode1 then
	        gatelockcode1 = true
	    else
	        gatelockcode1 = true
	    end
	end
	-- lock code2 lock code 52930 unlock code 76481
	if GetPlayerInteractShape() == number2 and InputPressed("interact") then
	    if gatelockcode1 and not gatelockcode2 then
	        gatelockcode2 = true
	    else
	        gatelockcode2 = false
	    end
	end
	-- lock code3 lock code 52930 unlock code 76481
	if GetPlayerInteractShape() == number9 and InputPressed("interact") then
	    if gatelockcode1 and gatelockcode2 and not gatelockcode3 then
	        gatelockcode3 = true
	    else
	        gatelockcode3 = false
	    end
	end
	-- lock code4 lock code 52930 unlock code 76481
	if GetPlayerInteractShape() == number3 and InputPressed("interact") then
	    if gatelockcode1 and gatelockcode2 and gatelockcode3 and not gatelockcode4 then
	        gatelockcode4 = true
	    else
	        gatelockcode4 = false
	    end
	end
	-- lock code5 lock code 52930 unlock code 76481
	if GetPlayerInteractShape() == number0 and InputPressed("interact") then
	    if gatelockcode1 and gatelockcode2 and gatelockcode3 and gatelockcode4 and not gatelockcode5 then
	        gatelockcode5 = true
	    else
	        gatelockcode5 = false
	    end
	end
	
	if gateunlockcode1 and gateunlockcode2 and gateunlockcode3 and gateunlockcode4 and gateunlockcode5 then
        if gatelocked then
		    gatelocked = false
	        gatelockcode1 = false
	        gatelockcode2 = false
	        gatelockcode3 = false
	        gatelockcode4 = false
	        gatelockcode5 = false
		end
	end
	if gatelockcode1 and gatelockcode2 and gatelockcode3 and gatelockcode4 and gatelockcode5 then
        if not gatelocked then
		    gatelocked = true
			gateunlockcode1 = false
	        gateunlockcode2 = false
	        gateunlockcode3 = false
	        gateunlockcode4 = false
	        gateunlockcode5 = false
		end
	end
	-- lock code 52930 unlock code 76481
    if gatelocked then
        if IsShapeInTrigger(trigger1, door) then
            for i=1,#gatemotors do
                local motor = gatemotors[i]
                SetJointMotorTarget(motor,0,0.5)
			end
        end
    end
	if not gatelocked then
        if IsShapeInTrigger(trigger1, door) then
            for i=1,#gatemotors do
                local motor = gatemotors[i]
                SetJointMotorTarget(motor,-0.3,0.5)
			end
        end
    end

end