function init()
	seconds = 0
	hours = 0
	minutes = 26
end
function tick(dt)	
	if seconds > 60 then
	    seconds = 0
		minutes = minutes + 1
	end
	if seconds >= 0 then
	    seconds = seconds + dt
	end
	
	if minutes == 60 then
	    minutes = 0
		hours = hours + 1
	end
	if hours == 12 then
	    hours = 0
	end
end


function draw()
    UiTranslate(UiCenter(), UiMiddle())
	UiAlign("center middle")
	UiColor(1,0,0)
	UiFont("bold.ttf", 100)
	if hours > 9 then
	
	    UiPush()
	        UiTranslate(-60,0)
	        UiText(hours)
	    UiPop()
	elseif hours < 10 then
	    UiPush()
	        UiTranslate(-90,0)
	        UiText("0")
	    UiPop()
	    UiPush()
	        UiTranslate(-40,0)
	        UiText(hours)
	    UiPop()
	end
	UiPush()
	    UiTranslate(0,0)
	    UiText(":")
	UiPop()
	if minutes > 9 then
	    UiPush()
	        UiTranslate(60,0)
	        UiText(minutes)
	    UiPop()
	end
	if minutes < 10 then
	    UiPush()
	        UiTranslate(40,0)
	        UiText("0")
	    UiPop()
	    UiPush()
	        UiTranslate(90,0)
	        UiText(minutes)
	    UiPop()
	end
end 