templates={
	weathers={
		--default enviroment in the editor, usueful for making an enviroment from scratch
		--and im not gonna copy what is what into here, its all avaliable inside the editor
		--also used as the default value for properties

		--note that the weather made from SetEnvironmentDefault() is completly same as the this one, except the fogParams, which is 0,0,0,0
		--which can make the enviroment look weird if called every tick, do not use SetEnvironmentDefault() when doing smooth weather transition
		
		default={
			skybox=				{"cloudy.dds"},
			skyboxtint=			{1, 1, 1},
			skyboxbrightness=	{1},
			skyboxrot=			{0},
			constant=			{.003, .003, .003},
			ambient=			{1},
			ambientexponent=	{1.3},
			fogColor=			{1, 1, 1},
			fogParams=			{40, 100, .9, 4},
			sunBrightness=		{0},
			sunColorTint=		{1, 1, 1},
			sunDir=				{0, 0, 0},
			sunSpread=			{0},
			sunLength=			{32},
			sunFogScale=		{1},
			sunGlare=			{1},
			exposure=			{0, 10},
			brightness=			{1},
			wetness=			{0},
			puddleamount=		{0},
			puddlesize=			{.5},
			rain=				{0},
			nightlight=			{true},
			ambience=			{"outdoor/field.ogg",1},
			fogscale=			{1},
			slippery=			{0},
			waterhurt=			{0},
			--snowdir=			{0,-1, 0, 0.2},
			--snowamount=			{0},
			--snowonground=		{false},
			--wind=				{0, 0, 0},
		},

		--these are enviroment templates modified based on the one in the game files, used for day-night cycle
		cycle={
			sunrise={
				skybox=				{"cloudy.dds"},
				skyboxtint=			{1, 0.4, 0.2},
				skyboxbrightness=	{0.6},
				fogColor=			{1, 0.2, 0.1},
				fogParams=			{30, 160, 0.95, 6},
				sunBrightness=		{0},
				sunColorTint=		{1, 1, 1},
				sunFogScale=		{1},
				sunGlare=			{1},
				exposure=			{1, 5},
				ambience=			{"outdoor/field.ogg"},
				nightlight=			{true},
			},
			sunny={
				skybox=				{"cloudy.dds"},
				skyboxtint=			{1, 1, 1},
				skyboxbrightness=	{0.7},
				fogColor=			{0.9, 0.9, 0.9},
				fogParams=			{50, 200, 0.9, 8},
				sunBrightness=		{4},
				sunColorTint=		{1, 0.8, 0.6},
				sunFogScale=		{0.15},
				sunGlare=			{1},
				exposure=			{1, 5},
				nightlight=			{false},
				ambience=			{"outdoor/field.ogg"},
			},
			sunset={
				skybox=				{"cloudy.dds"},
				skyboxtint=			{1, 0.45, 0.2},
				skyboxbrightness=	{1},
				fogColor=			{0.3, 0.15, 0.08},
				fogParams=			{80, 200, 1, 6},
				sunBrightness=		{1},
				sunColorTint=		{0.2, 0.3, 1},
				sunFogScale=		{1},
				sunGlare=			{0.8},
				exposure=			{1, 5},
				nightlight=			{false},
				ambience=			{"outdoor/field.ogg"},
			},
			night={
				skybox=				{"cloudy.dds"},
				skyboxtint=			{0, 0, 0},
				skyboxbrightness=	{0.001},
				fogColor=			{0.02, 0.02, 0.024},
				fogParams=			{80, 200, 0.9, 2},
				sunBrightness=		{0},
				sunColorTint=		{0, 0, 0},
				sunFogScale=		{0},
				sunGlare=			{0},
				exposure=			{1, 5},
				nightlight=			{true},
				ambience=			{"outdoor/night.ogg"},
			},
		},

		--rest are default enviroment templates nicked from the game files, also avaliable for the editor
		sunrise={
			skybox=				{"cloudy.dds"},
			skyboxtint=			{1, .4, .2},
			skyboxbrightness=	{.6},
			fogColor=			{1, .2, .1},
			fogParams=			{30, 160, 0.95, 6},
			exposure=			{1, 5},
		},
		sunny={
			skybox=				{"day.dds"},
			skyboxtint=			{1, 1, 1},
			fogColor=			{.9, .9, .9},
			fogParams=			{50, 200, 0.9, 8},
			sunBrightness=		{6},
			sunColorTint=		{1, .8, .6},
			sunFogScale=		{0.15},
			exposure=			{1, 5},
			nightlight=			{false},
		},
		sunset={
			skybox=				{"sunset.dds"},
			skyboxtint=			{1, .5, .2},
			skyboxbrightness=	{1},
			fogColor=			{.3, .2, .08},
			fogParams=			{80, 200, 1, 6},
			sunBrightness=		{1},
			sunColorTint=		{.2, .3, 1},
			sunFogScale=		{1},
			sunGlare=			{.8},
			exposure=			{1, 5},
			nightlight=			{true},
		},
		night={
			skybox=				{"cloudy.dds"},
			skyboxbrightness=	{.05},
			fogColor=			{.02, .02, .024},
			fogParams=			{20, 120, 0.9, 2},
			exposure=			{1, 5},
			nightlight=			{true},
			ambience=			{"outdoor/night.ogg"},
		},
		foggy={
			skybox=				{"cloudy.dds"},
			skyboxtint=			{1, .6, .4},
			fogColor=			{.2, .18, .15},
			fogParams=			{0, 60, .9, 3},
			exposure=			{1, 5},
			wetness=			{.4},
			puddleamount=		{.3},
			nightlight=			{false},
			slippery=			{.1},
		},
		rain={
			skybox=				{"cloudy.dds"},
			skyboxtint=			{1, .6, .4},
			fogColor=			{.1, .1, .1},
			fogParams=			{0, 70, .9, 1},
			exposure=			{1, 5},
			wetness=			{.5},
			puddleamount=		{.5},
			puddlesize=			{.7},
			rain=				{.5},
			nightlight=			{false},
			ambience=			{"outdoor/rain_light.ogg"},
			slippery=			{.2},
		},
		rainynight={
			skybox=				{"cloudy.dds"},
			skyboxbrightness=	{0.02},
			fogColor=			{0.02, 0.02, 0.024},
			fogParams=			{10, 90, 0.9, 2},
			exposure=			{1, 5},
			wetness=			{.7},
			puddleamount=		{.7},
			puddlesize=			{.7},
			rain=				{.9},
			nightlight=			{true},
			ambience=			{"outdoor/rain_heavy.ogg"},
			slippery=			{.3},
		},
	},
	pp={
		default={
			saturation=		{1},
			colorbalance=	{1, 1, 1},
			brightness=		{1},
			gamma=			{1},
			bloom=			{1},
		},
	},
}


--ordered list of enviroment properties, usueful for making the enviroment more user friendly to read
weather_properties={
	"skybox",
	"skyboxtint",
	"skyboxbrightness",
	"skyboxrot",
	"constant",
	"ambient",
	"ambientexponent",
	"fogColor",
	"fogParams",
	"sunBrightness",
	"sunColorTint",
	"sunDir",
	"sunSpread",
	"sunLength",
	"sunFogScale",
	"sunGlare",
	"exposure",
	"brightness",
	"wetness",
	"puddleamount",
	"puddlesize",
	"rain",
	"nightlight",
	"ambience",
	"fogscale",
	"slippery",
	"waterhurt",
	--"snowdir",
	--"snowamount",
	--"snowonground",
	--"wind",
}
--ordered list of post processing properties, usueful for making the post processing more user friendly to read
PP_properties={
	"saturation",
	"colorbalance",
	"brightness",
	"gamma",
	"bloom",
}